import * as i2$2 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { forwardRef, Component, Inject, Injectable, EventEmitter, TemplateRef, ViewChild, ViewEncapsulation, ViewChildren, ContentChildren, Injector, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import * as i2$3 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { BooleanInputConverter, OTranslateService, OCustomMaterialModule } from 'ontimize-web-ngx';
import { __decorate, __metadata } from 'tslib';
import * as i2 from '@angular/flex-layout/extended';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { MatTabGroup, MatTab } from '@angular/material/tabs';
import * as L from 'leaflet';
import * as i1$1 from '@angular/common/http';
import { HttpClient } from '@angular/common/http';
import { map, flatMap } from 'rxjs/operators';
import 'leaflet-contextmenu';
import 'leaflet-draw';
import 'leaflet-providers';
import 'leaflet.heat';
import 'leaflet.markercluster';
import 'proj4leaflet';
import * as i2$1 from '@angular/material/button';
import { BehaviorSubject, Subject, combineLatest } from 'rxjs';
import * as i2$4 from '@angular/material/expansion';
import * as i3$2 from '@angular/material/sidenav';
import * as i3$1 from '@angular/flex-layout/flex';
import * as i3 from '@angular/material/icon';

let OMapBase$1 = class OMapBase {
};

class OMapBaseLayerComponent {
    get oSearchResult() {
        return {
            label: this.name,
            icon: 'map',
            buttons: [{
                    icon: ['visibility', 'visibility_off'],
                    status: () => this.active,
                    callback: () => this.select()
                }]
        };
    }
    constructor(oMap) {
        this.oMap = oMap;
        this.active = false;
        this.oSearchKeys = ['name'];
    }
    ngOnInit() {
        if (this.oMap) {
            this.onMapReadySubscription = this.oMap.onMapAfterViewInit().subscribe(() => {
                this.oMap.getLMap().on('baselayerchange', (evt) => {
                    this.updateActiveState(evt.name);
                });
            });
        }
    }
    ngOnDestroy() {
        if (this.onMapReadySubscription) {
            this.onMapReadySubscription.unsubscribe();
        }
    }
    updateActiveState(layerId) {
        if (layerId === this.name) {
            this.active = true;
        }
        else {
            this.active = false;
        }
    }
    select() {
        this.oMap.unselectBaseLayers();
        this.oMap.getMapService().selectBaseLayer(this.id);
        return this.active = true;
    }
    get urlTemplate() {
        return this._urlTemplate;
    }
    set urlTemplate(val) {
        this._urlTemplate = val;
    }
    get name() {
        return this._name;
    }
    set name(val) {
        this._name = val;
    }
}
OMapBaseLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapBaseLayerComponent, deps: [{ token: forwardRef(() => OMapBase$1) }], target: i0.ɵɵFactoryTarget.Component });
OMapBaseLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapBaseLayerComponent, selector: "o-map-base-layer", inputs: { id: ["layer-id", "id"], name: ["title", "name"], urlTemplate: ["src", "urlTemplate"], active: "active" }, providers: [], ngImport: i0, template: "<button [class.active]=\"active\" (click)=\"select()\">\n\t<div class=\"image\"\n\t\t[ngStyle]=\"{'background-image': 'url(' + urlTemplate + ')'}\"></div>\n\t<div class=\"image-title\"\n\t\t>{{name}}</div>\n</button>", styles: [":host{float:left;width:112px}button{all:unset;position:relative;width:100%}button .image{height:112px;background-position:center center;background-repeat:no-repeat;background-size:cover}button .image-title{display:none;position:absolute;top:0;line-height:112px;width:100%;font-size:12px;text-align:center;background:rgba(255,255,255,.38)}button:hover .image-title{display:block}button.active{border:1px solid black}\n"], dependencies: [{ kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i2.DefaultStyleDirective, selector: "  [ngStyle],  [ngStyle.xs], [ngStyle.sm], [ngStyle.md], [ngStyle.lg], [ngStyle.xl],  [ngStyle.lt-sm], [ngStyle.lt-md], [ngStyle.lt-lg], [ngStyle.lt-xl],  [ngStyle.gt-xs], [ngStyle.gt-sm], [ngStyle.gt-md], [ngStyle.gt-lg]", inputs: ["ngStyle", "ngStyle.xs", "ngStyle.sm", "ngStyle.md", "ngStyle.lg", "ngStyle.xl", "ngStyle.lt-sm", "ngStyle.lt-md", "ngStyle.lt-lg", "ngStyle.lt-xl", "ngStyle.gt-xs", "ngStyle.gt-sm", "ngStyle.gt-md", "ngStyle.gt-lg"] }] });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapBaseLayerComponent.prototype, "active", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapBaseLayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-base-layer', providers: [], inputs: [
                        'id: layer-id',
                        'name: title',
                        'urlTemplate: src',
                        'active'
                    ], template: "<button [class.active]=\"active\" (click)=\"select()\">\n\t<div class=\"image\"\n\t\t[ngStyle]=\"{'background-image': 'url(' + urlTemplate + ')'}\"></div>\n\t<div class=\"image-title\"\n\t\t>{{name}}</div>\n</button>", styles: [":host{float:left;width:112px}button{all:unset;position:relative;width:100%}button .image{height:112px;background-position:center center;background-repeat:no-repeat;background-size:cover}button .image-title{display:none;position:absolute;top:0;line-height:112px;width:100%;font-size:12px;text-align:center;background:rgba(255,255,255,.38)}button:hover .image-title{display:block}button.active{border:1px solid black}\n"] }]
        }], ctorParameters: function () {
        return [{ type: OMapBase$1, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapBase$1)]
                    }] }];
    }, propDecorators: { active: [] } });

class Location {
}

class GeocodingService {
    constructor(httpClient) {
        this.httpClient = httpClient;
    }
    geocode(address) {
        return this.httpClient
            .get('http://maps.googleapis.com/maps/api/geocode/json?address=' + encodeURIComponent(address))
            .pipe(map((res) => res.json()))
            .pipe(map((result) => {
            if (result.status !== 'OK') {
                throw new Error('unable to geocode address');
            }
            const locations = result.results.map(r => {
                const location = new Location();
                location.address = r.formatted_address;
                location.latitude = r.geometry.location.lat;
                location.longitude = r.geometry.location.lng;
                return location;
            });
            return locations;
        }));
    }
    getCurrentLocation() {
        return this.httpClient
            .get('http://ipv4.myexternalip.com/json')
            .pipe(map((res) => res.json().ip))
            .pipe(flatMap(ip => this.httpClient.get('http://freegeoip.net/json/' + ip)))
            .pipe(map((res) => res.json()))
            .pipe(map((result) => {
            const location = new Location();
            location.address = result.city + ', ' + result.region_code + ' ' + result.zip_code + ', ' + result.country_code;
            location.latitude = result.latitude;
            location.longitude = result.longitude;
            return location;
        }));
    }
}
GeocodingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: GeocodingService, deps: [{ token: forwardRef(() => HttpClient) }], target: i0.ɵɵFactoryTarget.Injectable });
GeocodingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: GeocodingService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: GeocodingService, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: i1$1.HttpClient, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => HttpClient)]
                    }] }];
    } });

class BaseLayerDefault {
    constructor(baseLayer) {
        this.id = '';
        this.events = {
            onUpdate: new EventEmitter()
        };
        if (!!baseLayer) {
            this.setBaseLayer(baseLayer);
        }
    }
    getTileLayer() {
        return this.tileLayer || new L.TileLayer(this.urlTemplate, this.options);
    }
    setBaseLayer(baseLayer) {
        if (!!this.tileLayer) {
            this.events.onUpdate.emit(this.tileLayer);
        }
        this.name = baseLayer.name;
        this.options = baseLayer.options;
        this.options.pane = 'tilePane';
        this.urlTemplate = baseLayer.urlTemplate;
        this.active = baseLayer.active;
        this.tileLayer = baseLayer.tileLayer;
    }
}

const DEFAULT_BASE_LAYERS = {
    'OpenStreetMap': {
        name: 'OpenStreetMap',
        urlTemplate: 'http://{s}.tile.openstreetmap.fr/hot/{z}/{x}/{y}.png',
        options: {
            attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>, Tiles courtesy of <a href="http://hot.openstreetmap.org/" target= "_blank" > Humanitarian OpenStreetMap Team< /a>'
        }
    },
    'Esri': {
        name: 'Esri',
        urlTemplate: 'http://server.arcgisonline.com/ArcGIS/rest/services/World_Topo_Map/MapServer/tile/{z}/{y}/{x}',
        options: {
            attribution: 'Tiles &copy; Esri &mdash; Esri, DeLorme, NAVTEQ, TomTom, Intermap, iPC, USGS, FAO, NPS, NRCAN, GeoBase,'
                + ' Kadaster NL, Ordnance Survey, Esri Japan, METI, Esri China (Hong Kong), and the GIS User Community'
        }
    },
    'CartoDB': {
        name: 'CartoDB',
        urlTemplate: 'http://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}.png',
        options: {
            attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a> &copy;'
                + ' <a href="http://cartodb.com/attributions">CartoDB</a>'
        }
    }
};
class MapServiceUtils {
    static retrieveGeoJSONStyles(geoJsonFeature, options) {
        if (options && geoJsonFeature.properties) {
            if (geoJsonFeature.properties.stroke) {
                options.stroke = geoJsonFeature.properties.stroke;
            }
            if (geoJsonFeature.properties.color) {
                options.color = geoJsonFeature.properties.color;
            }
            if (geoJsonFeature.properties.weight) {
                options.weight = geoJsonFeature.properties.weight;
            }
            if (geoJsonFeature.properties.opacity) {
                options.opacity = geoJsonFeature.properties.opacity;
            }
            if (geoJsonFeature.properties.lineCap) {
                options.lineCap = geoJsonFeature.properties.lineCap;
            }
            if (geoJsonFeature.properties.lineJoin) {
                options.lineJoin = geoJsonFeature.properties.lineJoin;
            }
            if (geoJsonFeature.properties.dashArray) {
                options.dashArray = geoJsonFeature.properties.dashArray;
            }
            if (geoJsonFeature.properties.dashOffset) {
                options.dashOffset = geoJsonFeature.properties.dashOffset;
            }
            if (geoJsonFeature.properties.fill) {
                options.fill = geoJsonFeature.properties.fill;
            }
            if (geoJsonFeature.properties.fillColor) {
                options.fillColor = geoJsonFeature.properties.fillColor;
            }
            if (geoJsonFeature.properties.fillOpacity) {
                options.fillOpacity = geoJsonFeature.properties.fillOpacity;
            }
            if (geoJsonFeature.properties.fillRule) {
                options.fillRule = geoJsonFeature.properties.fillRule;
            }
            if (geoJsonFeature.properties.className) {
                options.className = geoJsonFeature.properties.className;
            }
        }
        return options;
    }
    static createDefaultBaseLayer(id, active = false) {
        let baseLayer;
        try {
            const tileLayer = L.tileLayer['provider'](id);
            if (tileLayer !== undefined) {
                let _url = tileLayer['_url'];
                if (window.location.protocol === 'https:') {
                    _url = _url.replace('http:', 'https:');
                }
                baseLayer = new BaseLayerDefault({
                    id: id,
                    name: id,
                    urlTemplate: _url,
                    active: active,
                    options: tileLayer['options'],
                    tileLayer: tileLayer
                });
            }
            else if (!baseLayer && Object.keys(DEFAULT_BASE_LAYERS).indexOf(id) > -1) {
                baseLayer = new BaseLayerDefault(this.getDefaultBaseLayerConfiguration(id));
            }
        }
        catch (e) {
            if (Object.keys(DEFAULT_BASE_LAYERS).indexOf(id) > -1) {
                baseLayer = new BaseLayerDefault(this.getDefaultBaseLayerConfiguration(id));
            }
        }
        return baseLayer;
    }
    static getDefaultBaseLayerConfiguration(id) {
        if (Object.keys(DEFAULT_BASE_LAYERS).indexOf(id) > -1) {
            const conf = DEFAULT_BASE_LAYERS[id];
            if (window.location.protocol === 'https:') {
                conf['urlTemplate'] = conf['urlTemplate'].replace('http:', 'https:');
            }
            return conf;
        }
        return void 0;
    }
}

const MAP = {
    en: {
        MAP_BASE_LAYERS: 'Base layers',
        MAP_LAYERS: 'Layers',
        MAP_WORKSPACE_LAYERS: 'Workspace',
        SEARCH_PLACEHOLDER: 'Enter a place to go...',
        'CONTEXTMENU.CENTER_MAP': 'Center map here',
        'CONTEXTMENU.ZOOM_IN': 'Zoom in',
        'CONTEXTMENU.ZOOM_OUT': 'Zoom out'
    },
    es: {
        MAP_BASE_LAYERS: 'Capas base',
        MAP_LAYERS: 'Capas',
        MAP_WORKSPACE_LAYERS: 'Espacio de trabajo',
        SEARCH_PLACEHOLDER: 'Introduce un lugar...',
        'CONTEXTMENU.CENTER_MAP': 'Centrar el mapa aquí',
        'CONTEXTMENU.ZOOM_IN': 'Acercar',
        'CONTEXTMENU.ZOOM_OUT': 'Alejar'
    }
};

class TranslateMapService {
    constructor(injector) {
        this.injector = injector;
        this.currentLang = 'en';
        try {
            this.oTranslateService = this.injector.get(OTranslateService);
            this.currentLang = this.oTranslateService.getCurrentLang();
            this.oTranslateService.onLanguageChanged.subscribe((lang) => {
                this.currentLang = lang;
            });
        }
        catch (ex) {
        }
    }
    get(text) {
        let textTranslated;
        try {
            if (this.oTranslateService) {
                const bundle = this.oTranslateService.get(text);
                if (bundle && bundle['value']) {
                    textTranslated = bundle['value'];
                }
                textTranslated = textTranslated === text ? undefined : textTranslated;
            }
        }
        catch (e) {
            textTranslated = undefined;
        }
        if (!textTranslated) {
            const bundle = MAP[this.currentLang];
            if (bundle && bundle[text]) {
                textTranslated = bundle[text];
            }
            else {
                textTranslated = text;
            }
        }
        return textTranslated;
    }
}

class BaseLayerCollection {
    constructor() {
        this.baseMaps = {};
        this.baseMapsOrderedList = [];
    }
    addLayer(id, layer) {
        if (layer instanceof BaseLayerDefault) {
            layer.id = id;
        }
        this.baseMaps[id] = layer;
        this.baseMapsOrderedList.push(id);
    }
    getLayer(id) {
        return this.contains(id) ? this.baseMaps[id] : undefined;
    }
    getTileLayer(id) {
        const layer = this.getLayer(id);
        if (layer instanceof BaseLayerDefault) {
            return layer.getTileLayer();
        }
        else if (layer instanceof L.TileLayer) {
            return layer;
        }
        return undefined;
    }
    getBaseLayers() {
        return this.baseMapsOrderedList
            .map(k => this.getLayer(k))
            .filter(l => l instanceof BaseLayerDefault);
    }
    getLayersMap() {
        const map = {};
        this.baseMapsOrderedList.forEach(k => {
            map[k] = this.getTileLayer(k);
        });
        return map;
    }
    getLayersArray() {
        const array = [];
        this.baseMapsOrderedList.forEach(k => {
            array.push(this.getTileLayer(k));
        });
        return array;
    }
    contains(id) {
        return this.baseMapsOrderedList.indexOf(id) > -1;
    }
}

const LAYERS_CONTROL_ID = 'layers';
class MapService {
    constructor(injector) {
        this.injector = injector;
        this.layers = {};
        this.controls = {};
        this.baseLayers = new BaseLayerCollection();
        this.overlayMaps = {};
        this.iconTypes = {};
        this.popupOptions = {
            maxHeight: 200
        };
        this.defaultContextMenu = {
            contextmenuItems: [{
                    attr: 'centerMap',
                    label: 'CONTEXTMENU.CENTER_MAP',
                    callback: (e) => this.centerMap(e)
                }, {
                    label: '',
                    separator: true
                }, {
                    attr: 'zoomIn',
                    label: 'CONTEXTMENU.ZOOM_IN',
                    icon: 'assets/zoom-in.png',
                    callback: () => this.zoomIn()
                }, {
                    attr: 'zoomOut',
                    label: 'CONTEXTMENU.ZOOM_OUT',
                    icon: 'assets/zoom-out.png',
                    callback: () => this.zoomOut()
                }]
        };
        this.baseLayerSelected = new EventEmitter();
        this.translateMapService = this.injector.get(TranslateMapService);
    }
    centerMap(e) {
        this.getMap().panTo(e.latlng);
    }
    zoomIn() {
        this.getMap().zoomIn();
    }
    zoomOut() {
        this.getMap().zoomOut();
    }
    disableMouseEvent(tag) {
        var html = L.DomUtil.get(tag);
        L.DomEvent.disableClickPropagation(html);
        L.DomEvent.on(html, 'mousewheel', L.DomEvent.stopPropagation);
    }
    getMap(id, options) {
        if (!!id && !this.map) {
            this.map = new L.Map(id, options);
        }
        return this.map;
    }
    setCenter(latitude, longitude) {
        this.map.setView([latitude, longitude], this.map.getZoom());
    }
    getCenter() {
        return this.map.getCenter();
    }
    setZoom(zoom) {
        this.map.setZoom(zoom);
    }
    getZoom() {
        return this.getZoom();
    }
    getDefaultContextmenuItems() {
        return this.defaultContextMenu;
    }
    addLayer(id, layer, hidden = false, showInMenu = '', menuLabel) {
        if (this.layers[id]) {
            this.map.removeLayer(this.layers[id]);
        }
        if (menuLabel) {
        }
        else {
            menuLabel = id;
        }
        switch (showInMenu) {
            case 'base':
                if (this.controls[LAYERS_CONTROL_ID] && this.baseLayers.contains(menuLabel)) {
                    this.controls[LAYERS_CONTROL_ID].removeLayer(this.baseLayers.getTileLayer(menuLabel));
                }
                this.layers[id] = menuLabel;
                this.baseLayers.addLayer(menuLabel, layer);
                if (this.controls[LAYERS_CONTROL_ID]) {
                    this.controls[LAYERS_CONTROL_ID].addBaseLayer(layer, menuLabel);
                }
                else {
                    this.controls[LAYERS_CONTROL_ID] = L.control.layers(this.baseLayers.getLayersMap()).addTo(this.map);
                }
                break;
            case 'overlay':
                if (this.controls[LAYERS_CONTROL_ID] && this.overlayMaps[menuLabel]) {
                    this.controls[LAYERS_CONTROL_ID].removeLayer(this.overlayMaps[menuLabel]);
                }
                this.layers[id] = menuLabel;
                this.overlayMaps[menuLabel] = layer;
                if (this.controls[LAYERS_CONTROL_ID]) {
                    this.controls[LAYERS_CONTROL_ID].addOverlay(layer, menuLabel);
                }
                else {
                    this.controls[LAYERS_CONTROL_ID] = L.control.layers(void 0, this.overlayMaps).addTo(this.map);
                }
                break;
            default:
                this.layers[id] = layer;
                break;
        }
        if (!hidden) {
            layer.addTo(this.map);
        }
    }
    addDrawLayer(layer) {
        this.drawLayerId = Math.random().toString(36);
        const label = this.translateMapService.get('draw-control-layer');
        this.addLayer(this.drawLayerId, layer, false, 'overlay', label);
    }
    removeDrawLayer() {
        this.removeLayer(this.drawLayerId);
    }
    getDrawLayer() {
        return this.overlayMaps[this.layers[this.drawLayerId]];
    }
    configureBaseLayers(baseLayerIds) {
        if (baseLayerIds && baseLayerIds.length > 0) {
            baseLayerIds.forEach((id, index) => {
                if (!this.baseLayers.contains(id)) {
                    const bl = MapServiceUtils.createDefaultBaseLayer(id, index === 0);
                    if (bl) {
                        this.baseLayers.addLayer(id, bl);
                    }
                }
            });
        }
        else {
            this.baseLayers.addLayer(MapService.DEFAULT_BASE_MAP, MapServiceUtils.createDefaultBaseLayer(MapService.DEFAULT_BASE_MAP, true));
        }
    }
    selectBaseLayer(id) {
        const l = this.baseLayers.getTileLayer(id);
        if (!!l) {
            this.clearBaseLayers();
            l.addTo(this.getMap());
            this.baseLayerSelected.emit(true);
        }
    }
    uploadBaseLayers() {
        const lM = this.baseLayers.getLayersMap();
        this.clearBaseLayers();
        this.controls[LAYERS_CONTROL_ID] = L.control.layers(lM).addTo(this.getMap());
    }
    clearBaseLayers() {
        const lM = this.baseLayers.getLayersMap();
        for (let layerId in lM) {
            if (lM.hasOwnProperty(layerId)) {
                const layer = this.baseLayers.getTileLayer(layerId);
                this.map.removeLayer(layer);
            }
        }
    }
    removeLayer(id) {
        let success = false;
        let layer;
        if (this.controls[LAYERS_CONTROL_ID]) {
            if ((typeof (this.layers[id]) === 'string')) {
                const menuLabel = this.layers[id];
                if (this.overlayMaps[menuLabel]) {
                    layer = this.overlayMaps[menuLabel];
                }
            }
            else if (this.baseLayers.contains(id)) {
                layer = this.baseLayers.getTileLayer(id);
            }
            if (!!layer) {
                this.controls[LAYERS_CONTROL_ID].removeLayer(layer);
                this.map.removeLayer(layer);
                success = true;
            }
            delete this.layers[id];
        }
        return success;
    }
    clearLayers() {
        for (let layerId in this.layers) {
            if (this.layers.hasOwnProperty(layerId)) {
                this.removeLayer(layerId);
            }
        }
        this.layers = {};
    }
    getLayer(id) {
        let layer;
        if ((typeof (this.layers[id]) === 'string') && this.controls[LAYERS_CONTROL_ID]) {
            const menuLabel = this.layers[id];
            layer = this.overlayMaps[menuLabel] || undefined;
        }
        else if (this.baseLayers.contains(id) && this.controls[LAYERS_CONTROL_ID]) {
            layer = this.baseLayers.getTileLayer(id);
        }
        else {
            layer = this.layers[id];
        }
        return layer;
    }
    createIconType(id, options) {
        this.iconTypes[id] = L.Icon.extend({
            options: options
        });
        return this.iconTypes[id];
    }
    createIcon(options, type) {
        let icon = void 0;
        if (type) {
            const iconType = this.iconTypes[type];
            if (iconType) {
                icon = new iconType(options);
            }
        }
        else {
            icon = L.icon(options);
        }
        return icon;
    }
    addTileLayer(id, template, options, hidden, showInMenu, menuLabel) {
        let tileLayer = null;
        tileLayer = new L.TileLayer(template, options);
        if (tileLayer !== null) {
            this.addLayer(id, tileLayer, hidden, showInMenu, menuLabel);
        }
        return tileLayer;
    }
    addTileLayerWMS(id, baseUrl, optionsArg = {}, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const tileLayerWMS = new L.TileLayer.WMS(baseUrl, optionsArg.layerOptions);
        this.addLayer(id, tileLayerWMS, hidden, showInMenu, menuLabel);
        return tileLayerWMS;
    }
    addMarker(id, latitude, longitude, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const latLng = new L.LatLng(latitude, longitude);
        if (optionsArg.iconOptions) {
            var iconOptions = { iconUrl: '' };
            Object.assign(iconOptions, optionsArg.iconOptions);
            optionsArg.layerOptions = optionsArg.layerOptions ? optionsArg.layerOptions : {};
            optionsArg.layerOptions.icon = L.icon(iconOptions);
        }
        const marker = L.marker(latLng, optionsArg.layerOptions);
        if (typeof (popup) === 'string') {
            marker.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, marker, hidden, showInMenu, menuLabel);
        return marker;
    }
    addImageOverlay(id, url, left, bottom, right, top, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const bounds = new L.LatLngBounds([[bottom, left], [top, right]]);
        const image = new L.ImageOverlay(url, bounds, optionsArg.layerOptions);
        if (typeof (popup) === 'string') {
        }
        this.addLayer(id, image, hidden, showInMenu, menuLabel);
        return image;
    }
    addPolyline(id, points, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const polyline = new L.Polyline(points, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            polyline.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, polyline, hidden, showInMenu, menuLabel);
        return polyline;
    }
    addMultiPolyline(id, points, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const multiPolyline = new L.MultiPolyline(points, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            multiPolyline.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, multiPolyline, hidden, showInMenu, menuLabel);
        return multiPolyline;
    }
    addPolygon(id, points, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const polygon = new L.Polygon(points, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            polygon.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, polygon, hidden, showInMenu, menuLabel);
        return polygon;
    }
    addMultiPolygon(id, points, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const multiPolygon = new L.MultiPolygon(points, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            multiPolygon.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, multiPolygon, hidden, showInMenu, menuLabel);
        return multiPolygon;
    }
    addRectangle(id, left, bottom, right, top, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const bounds = new L.LatLngBounds([[bottom, left], [top, right]]);
        const rectangle = new L.Rectangle(bounds, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            rectangle.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, rectangle, hidden, showInMenu, menuLabel);
        return rectangle;
    }
    addCircle(id, latitude, longitude, radius, optionsArg = {}, popup, hidden, showInMenu, menuLabel) {
        optionsArg = optionsArg ? optionsArg : {};
        const circle = new L.Circle([latitude, longitude], radius, optionsArg.layerStyles);
        if (typeof (popup) === 'string') {
            circle.bindPopup(popup, optionsArg.popupOptions);
        }
        this.addLayer(id, circle, hidden, showInMenu, menuLabel);
        return circle;
    }
    addLayerGroup(id, layers, hidden, showInMenu, menuLabel) {
        const layerGroup = L.layerGroup(layers);
        this.addLayer(id, layerGroup, hidden, showInMenu, menuLabel);
        return layerGroup;
    }
    addFeatureGroup(id, layers, popup, hidden, showInMenu, menuLabel) {
        const featureGroup = L.featureGroup(layers);
        if (typeof (popup) === 'string') {
            featureGroup.bindPopup(popup, this.popupOptions);
        }
        this.addLayer(id, featureGroup, hidden, showInMenu, menuLabel);
        return featureGroup;
    }
    addGeoJSON(id, data, optionsArg = {}, popup, hidden, showInMenu, menuLabel, contextmenu) {
        optionsArg = optionsArg ? optionsArg : {};
        const iconOptions = optionsArg.iconOptions;
        let customIconFromProps;
        if (iconOptions) {
            customIconFromProps = iconOptions.iconFromProperties;
            delete iconOptions.iconFromProperties;
        }
        const self = this;
        const geoJson = L.geoJSON(data, {
            pointToLayer: (feature, latlng) => {
                optionsArg.layerOptions = optionsArg.layerOptions ? optionsArg.layerOptions : {};
                if (customIconFromProps && feature && feature.properties[customIconFromProps]) {
                    iconOptions.iconUrl = feature.properties[customIconFromProps];
                }
                if (iconOptions) {
                    optionsArg.layerOptions.icon = new L.Icon(iconOptions);
                }
                else {
                    optionsArg.layerOptions.icon = new L.Icon.Default();
                }
                return L.marker(latlng, optionsArg.layerOptions);
            },
            style: geoJsonFeature => {
                return MapServiceUtils.retrieveGeoJSONStyles(geoJsonFeature, optionsArg.layerStyles);
            },
            onEachFeature: (feature, layer) => {
                if (contextmenu) {
                    if (contextmenu.callback) {
                        contextmenu['contextmenuItems'] = self.parseContextmenuItems(contextmenu.callback(layer));
                    }
                    layer.bindContextMenu({
                        contextmenu: true,
                        contextmenuItems: contextmenu['contextmenuItems'],
                        contextmenuWidth: contextmenu['contextmenuWidth'],
                        contextmenuInheritItems: false
                    });
                }
                if (popup && Object.keys(feature.properties).length > 0) {
                    try {
                        layer.bindPopup('', optionsArg.popupOptions).on('popupopen', (e) => {
                            const txt = this.popupTemplate(popup, feature.properties);
                            e.popup.setContent(txt);
                        });
                    }
                    catch (error) {
                        console.log(error);
                    }
                }
            }
        });
        this.addLayer(id, geoJson, hidden, showInMenu, menuLabel);
        return geoJson;
    }
    parseContextmenuItems(items) {
        return items.map((element) => {
            const item = new Object();
            if (element instanceof Object) {
                if (element.hasOwnProperty('label')) {
                    item['text'] = this.translateMapService.get(element.label);
                }
                if (element.hasOwnProperty('icon') && element.icon) {
                    item['icon'] = element.icon;
                }
                if (element.hasOwnProperty('iconCls') && element.iconCls) {
                    item['iconCls'] = element.iconCls;
                }
                if (element.hasOwnProperty('callback') && element.callback) {
                    item['callback'] = element.callback;
                }
                if (element.hasOwnProperty('index') && element.index) {
                    item['index'] = element.index;
                }
                if (element.hasOwnProperty('separator') && element.separator) {
                    item['separator'] = element.separator;
                }
                return item;
            }
            else {
                return element;
            }
        });
    }
    popupTemplate(str, data) {
        const templateRe = /\{ *([\w_\-]+) *\}/g;
        return str.replace(templateRe, (strV, key) => {
            let value = data[key];
            if (value === undefined) {
                value = '';
            }
            else if (typeof value === 'function') {
                value = value(data);
            }
            return value;
        });
    }
}
MapService.DEFAULT_BASE_MAP = 'OpenStreetMap.HOT';
MapService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: MapService, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
MapService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: MapService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: MapService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class Util {
    static parseBoolean(value, defaultValue) {
        if ((typeof value === 'string') && (value.toUpperCase() === 'TRUE' || value.toUpperCase() === 'YES')) {
            return true;
        }
        else if ((typeof value === 'string') && (value.toUpperCase() === 'FALSE' || value.toUpperCase() === 'NO')) {
            return false;
        }
        else if (defaultValue !== undefined || defaultValue !== null) {
            return defaultValue;
        }
        return false;
    }
    static parseArray(value) {
        if (value) {
            return value.split(';');
        }
        return [];
    }
    static isLayerService(arg) {
        return arg && (arg.load !== undefined);
    }
    static isGeoJSONLayer(arg) {
        return arg && (arg.addData !== undefined);
    }
    static isTileLayer(arg) {
        return arg && (arg.setZIndex !== undefined && arg.on !== undefined);
    }
    static isBlank(value) {
        let isBlank = false;
        if (value === undefined || value === null || value.length === 0) {
            isBlank = true;
        }
        return isBlank;
    }
}

class OMapLayerContainerComponent {
    constructor() {
    }
}
OMapLayerContainerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerContainerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OMapLayerContainerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapLayerContainerComponent, selector: "o-map-layer-container", inputs: { label: "label" }, host: { properties: { "class.o-map-layer-container": "true" } }, viewQueries: [{ propertyName: "headerTemplateref", first: true, predicate: ["headerTemplateref"], descendants: true, read: TemplateRef }], ngImport: i0, template: "<ng-template #headerTemplateref>\n  <ng-content select=\"[o-map-layer-container-header]\"></ng-content>\n</ng-template>\n\n<ng-content></ng-content>" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-layer-container', inputs: [
                        'label'
                    ], host: {
                        '[class.o-map-layer-container]': 'true'
                    }, template: "<ng-template #headerTemplateref>\n  <ng-content select=\"[o-map-layer-container-header]\"></ng-content>\n</ng-template>\n\n<ng-content></ng-content>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { headerTemplateref: [{
                type: ViewChild,
                args: ['headerTemplateref', { read: TemplateRef }]
            }] } });

class OMarkerComponent {
    constructor(mapService) {
        this.editing = false;
        this.removing = false;
        this.markerCount = 0;
        this.mapService = mapService;
    }
    ngOnInit() {
        this.mapService.disableMouseEvent('add-marker');
        this.mapService.disableMouseEvent('remove-marker');
    }
    Initialize() {
        this.mapService.map.on('click', (e) => {
            if (this.editing) {
                const marker = L.marker(e.latlng, {
                    draggable: true
                }).bindPopup('Marker #' + (this.markerCount + 1).toString(), {
                    offset: L.point(12, 6)
                }).addTo(this.mapService.map);
                this.markerCount += 1;
                marker.on('click', () => {
                    if (this.removing) {
                        this.mapService.map.removeLayer(marker);
                        this.markerCount -= 1;
                    }
                });
            }
        });
    }
    toggleEditing() {
        this.editing = !this.editing;
        if (this.editing === true && this.removing === true) {
            this.removing = false;
        }
    }
    toggleRemoving() {
        this.removing = !this.removing;
        if (this.editing === true && this.removing === true) {
            this.editing = false;
        }
    }
    get editing() {
        return this._editing;
    }
    set editing(val) {
        this._editing = val;
    }
    get removing() {
        return this._removing;
    }
    set removing(val) {
        this._removing = val;
    }
}
OMarkerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMarkerComponent, deps: [{ token: MapService }], target: i0.ɵɵFactoryTarget.Component });
OMarkerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMarkerComponent, selector: "o-marker", ngImport: i0, template: "<button mat-button id=\"add-marker\"\n\tclass=\"mat-icon-button mat-primary on-map-absolute\"\n\t[class.btn-default]=\"!editing\"\n\t[class.btn-primary]=\"editing\"\n\t[disabled]=\"removing\"\n\ttitle=\"Add Marker\"\n\t(click)=\"toggleEditing()\">\n\t\t<i class=\"material-icons\">add_location</i>\n</button>\n<button mat-button id=\"remove-marker\"\n\tclass=\"mat-icon-button mat-primary on-map-absolute\"\n\t[class.btn-default]=\"!removing\"\n\t[class.btn-primary]=\"removing\"\n\t[disabled]=\"editing\"\n\ttitle=\"Remove Marker\"\n\t(click)=\"toggleRemoving()\">\n\t\t<i class=\"material-icons\">delete</i>\n</button>\n", styles: ["#add-marker{margin:0 0 0 515px;top:10px}#remove-marker{margin:0 0 0 550px;top:10px}\n"], dependencies: [{ kind: "component", type: i2$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMarkerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-marker', template: "<button mat-button id=\"add-marker\"\n\tclass=\"mat-icon-button mat-primary on-map-absolute\"\n\t[class.btn-default]=\"!editing\"\n\t[class.btn-primary]=\"editing\"\n\t[disabled]=\"removing\"\n\ttitle=\"Add Marker\"\n\t(click)=\"toggleEditing()\">\n\t\t<i class=\"material-icons\">add_location</i>\n</button>\n<button mat-button id=\"remove-marker\"\n\tclass=\"mat-icon-button mat-primary on-map-absolute\"\n\t[class.btn-default]=\"!removing\"\n\t[class.btn-primary]=\"removing\"\n\t[disabled]=\"editing\"\n\ttitle=\"Remove Marker\"\n\t(click)=\"toggleRemoving()\">\n\t\t<i class=\"material-icons\">delete</i>\n</button>\n", styles: ["#add-marker{margin:0 0 0 515px;top:10px}#remove-marker{margin:0 0 0 550px;top:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: MapService }]; } });

class OMapDrawControlsEvents {
    constructor(editableLayers) {
        this.editableLayers = editableLayers;
        this.onDrawEvent = new EventEmitter();
    }
    setMap(arg) {
        this.map = arg;
        this.registerMapEvents();
    }
    registerMapEvents() {
        this.map.on('draw:created', (data) => {
            this.editableLayers.addLayer(data.layer);
            this.onDrawEvent.emit({ event: 'onDrawCreated', data: data });
        });
        this.map.on('draw:edited', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEdited', data: data });
        });
        this.map.on('draw:deleted', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawDeleted', data: data });
        });
        this.map.on('draw:drawstart', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawDrawStart', data: data });
        });
        this.map.on('draw:drawstop', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawDrawstop', data: data });
        });
        this.map.on('draw:drawvertex', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawvertex', data: data });
        });
        this.map.on('draw:editstart', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEditStart', data: data });
        });
        this.map.on('draw:editmove', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEditMove', data: data });
        });
        this.map.on('draw:editresize', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEditResize', data: data });
        });
        this.map.on('draw:editvertex', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEditvertex', data: data });
        });
        this.map.on('draw:editstop', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawEditStop', data: data });
        });
        this.map.on('draw:deletestart', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawDeleteStart', data: data });
        });
        this.map.on('draw:deletestop', (data) => {
            this.onDrawEvent.emit({ event: 'onDrawDeleteStop', data: data });
        });
    }
    observable() {
        return this.onDrawEvent.asObservable();
    }
}

class LayerGroupConfiguration {
    constructor() {
        this.mapLayers = new Array();
        this.layerGroupsWarehouse = new OMapLayerGroupsWarehouse();
    }
    addLayerConfiguration(layerConf) {
        if (layerConf) {
            this.mapLayers.push(layerConf);
        }
    }
}

class OMapLayerGroupsWarehouse {
    constructor() {
        this.all = [];
        this.map = {};
    }
    get(id) {
        let group;
        const position = this.map[id];
        if (position === undefined) {
            group = new LayerGroupConfiguration();
            group.id = id;
            this.push(group);
        }
        else {
            group = this.all[position];
        }
        return group;
    }
    push(g) {
        const p = this.map[g.id];
        if (p === undefined) {
            this.map[g.id] = this.all.length;
            this.all.push(g);
        }
        else {
            g.mapLayers = g.mapLayers.concat(this.all[p].mapLayers);
            g.layerGroupsWarehouse.concat(this.all[p].layerGroupsWarehouse);
            this.all[p] = g;
        }
    }
    concat(gw) {
        gw.all.forEach(lgw => {
            this.push(lgw);
        });
    }
}

class Center {
    constructor(lat, lng) {
        this.latitude = lat;
        this.longitude = lng;
    }
}

const DEFAULT_CENTER = new Center(42.2274519, -8.7236805);
class OMapBase {
    constructor() {
        this.zoom = { control: true };
        this.mapBaseLayerGroup = new Array();
        this.mapLayers = new Array();
        this.mapConfiguration = new EventEmitter();
        this.mapAfterViewInit = new EventEmitter();
        this.mapReady = new BehaviorSubject(undefined);
    }
    getOMapLayer(layerId) {
        return this.mapLayers.filter(layer => layer.layerId === layerId).shift();
    }
    getOMapLayers() {
        return this.mapLayers;
    }
    addOMapLayer(layer) {
        this.mapLayers.push(layer);
    }
    getMapService() {
        return this.mapService;
    }
    getLMap() {
        return this.getMapService().map;
    }
    getCenter() {
        return this.center || DEFAULT_CENTER;
    }
    setCenter(sCenter) {
        if (Util.isBlank(sCenter)) {
            this.center = DEFAULT_CENTER;
        }
        else {
            const coordinates = sCenter.split(/,|;/);
            if (coordinates.length === 2) {
                const latitude = parseFloat(coordinates[0]);
                const longitude = parseFloat(coordinates[1]);
                this.center = new Center(latitude, longitude);
            }
            else {
                this.center = DEFAULT_CENTER;
            }
        }
        const map = this.getMapService().map;
        if (!Util.isBlank(map)) {
            map.panTo([this.center.latitude, this.center.longitude]);
        }
    }
    addMarker(id, latitude, longitude, options, popup, hidden, showInMenu, menuLabel) {
        this.mapService.addMarker(id, latitude, longitude, options, popup, hidden, showInMenu, menuLabel);
    }
    onMapConfigured() {
        return this.mapConfiguration;
    }
    onMapAfterViewInit() {
        return this.mapAfterViewInit;
    }
    onMapReady() {
        return this.mapReady;
    }
}

class OMapWEvents extends OMapBase {
    constructor() {
        super();
        this.onClick = new EventEmitter();
        this.onDrag = new EventEmitter();
        this.onMove = new EventEmitter();
        this.onMoveEnd = new EventEmitter();
        this.onZoomLevelsChange = new EventEmitter();
        this.onZoomStart = new EventEmitter();
        this.onZoomEnd = new EventEmitter();
        this.onZoom = new EventEmitter();
        this.onDrawEvent = new EventEmitter();
        this.onDrawCreated = new EventEmitter();
        this.onDrawEdited = new EventEmitter();
        this.onDrawDeleted = new EventEmitter();
        this.onDrawDrawStart = new EventEmitter();
        this.onDrawDrawstop = new EventEmitter();
        this.onDrawvertex = new EventEmitter();
        this.onDrawEditStart = new EventEmitter();
        this.onDrawEditMove = new EventEmitter();
        this.onDrawEditResize = new EventEmitter();
        this.onDrawEditvertex = new EventEmitter();
        this.onDrawEditStop = new EventEmitter();
        this.onDrawDeleteStart = new EventEmitter();
        this.onDrawDeleteStop = new EventEmitter();
        this.onMapConfigured().subscribe(() => {
            ['Click', 'Drag', 'Move', 'MoveEnd', 'ZoomLevelsChange', 'ZoomStart', 'ZoomEnd', 'Zoom'].forEach(eventName => {
                this.getMapService().map.on(eventName.toLowerCase(), (evt) => {
                    this['on' + eventName].emit(evt);
                });
            });
        });
        this.onMapAfterViewInit().subscribe((oMap) => {
            const observable = oMap.getDrawControlEventsObservable();
            if (observable) {
                observable.subscribe((args) => {
                    this.onDrawEvent.emit(args.data);
                    this[args.event].emit(args.data);
                });
            }
        });
    }
}

class OMapWSidenav extends OMapWEvents {
    constructor() {
        super(...arguments);
        this._isSidenavVisible = false;
    }
    toggleSidenav(e) {
        if (e) {
            e.stopPropagation();
            e.preventDefault();
        }
        if (this.sideNavCmp) {
            if (this.isSidenavVisible) {
                this.sideNavCmp.close();
            }
            else {
                this.sideNavCmp.open();
            }
            setTimeout(() => {
                this.getMapService().map.invalidateSize(true);
                if (!this.sideNavCmp.opened) {
                    const evt = new UIEvent('resize');
                    window.dispatchEvent(evt);
                }
            }, 0);
        }
        this.isSidenavVisible = !this.isSidenavVisible;
    }
    get isSidenavVisible() {
        return this._isSidenavVisible;
    }
    set isSidenavVisible(val) {
        this._isSidenavVisible = val;
    }
}

class OMapWLayers extends OMapWSidenav {
    constructor() {
        super(...arguments);
        this.auxLayerGroupWarehouse = new OMapLayerGroupsWarehouse();
    }
    addOMapLayerGroupsConfiguration(groups) {
        if (!groups || groups.length === 0) {
            return;
        }
        groups.forEach(layerGroup => {
            this.addOMapLayerGroupConfiguration(layerGroup);
        });
    }
    addOMapLayerGroupConfiguration(layerGroup) {
        if (!layerGroup) {
            return;
        }
        this.auxLayerGroupWarehouse.push(layerGroup);
        if (layerGroup.idParent) {
            this.auxLayerGroupWarehouse.get(layerGroup.idParent).layerGroupsWarehouse.push(layerGroup);
        }
        else {
            this.mapLayerGroup.mLayerGroupsWarehouse.push(layerGroup);
        }
    }
    addOMapLayerConfiguration(layer) {
        if (!layer) {
            return;
        }
        if (layer.layerGroupId) {
            this.auxLayerGroupWarehouse.get(layer.layerGroupId).mapLayers.push(layer);
        }
        else {
            this.mapLayerGroup.mapLayers.push(layer);
        }
    }
}

class OMapWWorkspace extends OMapWLayers {
    getWorkspaceMapLayers() {
        if (!this.mapWorkspace) {
            return [];
        }
        return this.mapWorkspace.getMapLayers();
    }
    getWorkspaceSelectedMapLayer() {
        if (!this.mapWorkspace) {
            return undefined;
        }
        return this.mapWorkspace.getSelectedMapLayer();
    }
}

class OMapWDraw extends OMapWWorkspace {
    constructor() {
        super(...arguments);
        this.drawDefaultControl = false;
    }
    registerDrawControlComponent(drawControlComponent) {
        this.drawControlComponent = drawControlComponent;
    }
    getDrawControlEventsObservable() {
        let controlEvents = this.defaultDrawControlEvents;
        if (this.drawControlComponent && this.drawControlComponent.drawControlEvents) {
            controlEvents = this.drawControlComponent.drawControlEvents;
        }
        return controlEvents ? controlEvents.observable() : undefined;
    }
    configureDefaultDrawControl(map) {
        const editableLayers = new L.FeatureGroup();
        const mapService = this.getMapService();
        mapService.addDrawLayer(editableLayers);
        const options = {
            position: 'topright',
            draw: {
                polygon: {
                    allowIntersection: false
                }
            },
            edit: {
                featureGroup: editableLayers,
                remove: true
            }
        };
        const drawControl = new L.Control.Draw(options);
        map.addControl(drawControl);
        this.defaultDrawControlEvents = new OMapDrawControlsEvents(editableLayers);
        this.defaultDrawControlEvents.setMap(map);
    }
}

class OMapWMarkerCluster extends OMapWDraw {
}

class OMapWBaseLayer extends OMapWMarkerCluster {
    constructor() {
        super();
        this.baseLayersGroup = new Array();
        this.onMapConfigured().subscribe(() => {
            this.getMapService().uploadBaseLayers();
            const bLayers = this.getMapService().baseLayers.getBaseLayers();
            if (bLayers && bLayers.length > 0) {
                const layerId = bLayers[0].id;
                this.getMapService().selectBaseLayer(layerId);
            }
        });
    }
    get baseLayers() {
        let newBaseLayerGroup = this.getMapService().baseLayers.getBaseLayers();
        if (this.baseLayersGroup.length !== newBaseLayerGroup.length) {
            this.baseLayersGroup = newBaseLayerGroup.map(bL => this.buildBaseLayerUrl(bL));
        }
        return this.baseLayersGroup;
    }
    unselectBaseLayers() {
        this.mapBaseLayerGroup.forEach(bL => bL.active = false);
    }
    buildBaseLayerUrl(bL) {
        let url = bL.urlTemplate.replace('{s}', 'b').replace('{x}', '974').replace('{y}', '758').replace('{z}', '11');
        if (url && url.indexOf('//') === 0) {
            url = 'http:' + url;
        }
        if (url.indexOf('{variant}') > -1) {
            url = url.replace('{variant}', bL.options['variant']);
        }
        return {
            id: bL.id,
            active: bL.active,
            name: bL.name,
            urlTemplate: url
        };
    }
}

class SearcherDefault {
    get oSearchableCollection() {
        return this.collection();
    }
    constructor(title, collection) {
        this.oSearchTitle = '';
        this.oSearcherCollection = [];
        if (!!title) {
            this.oSearchTitle = title;
        }
        this.setSearchableCollection(collection);
    }
    search(oSearchValue) {
        const subject = new Subject();
        setTimeout(() => subject.next(this.oSearchableCollection.filter(sc => {
            let r = false;
            const l = sc.oSearchKeys.length;
            for (let i = 0; i < l && !r; i++) {
                const k = sc.oSearchKeys[i];
                const t = sc[k] ? this.transformSearchTerm(sc[k]) : '';
                r = t.indexOf(this.transformSearchTerm(oSearchValue)) > -1;
            }
            return r;
        })), 1);
        return subject.asObservable();
    }
    setSearchableCollection(collection) {
        return this.collection = collection;
    }
    transformSearchTerm(s) {
        let t = s.toLowerCase();
        t = t.replace(/[ç]/g, 'c')
            .replace(/[àáäâã]/g, 'a')
            .replace(/[èéëê]/g, 'e')
            .replace(/[ìíïî]/g, 'i')
            .replace(/[òóöôõ]/g, 'o')
            .replace(/[ùúüû]/g, 'u');
        t = t.replace(/\bel\b/g, 'o')
            .replace(/\bla\b/g, 'a')
            .replace(/(ua)/g, 'a')
            .replace(/(ie|ei)/g, 'e')
            .replace(/(ou|ue)/g, 'o')
            .replace(/(ll|y|lh|ie)/g, 'i')
            .replace(/(nh|nn|ny|ñ)/g, 'n')
            .replace(/(ch)/g, 'c')
            .replace(/(gh)/g, 'g')
            .replace(/(j|g)/g, 'x')
            .replace(/\b(h)/g, 'f')
            .replace(/(ito)/g, 'ino')
            .replace(/(aa|ee|ii|oo|uu)/g, r => r[0]);
        return t;
    }
}

class OMapWSearch extends OMapWBaseLayer {
    constructor() {
        super(...arguments);
        this.oSearchTitle = '';
        this.oSearchableCollection = null;
        this._searchControl = true;
        this.mapSearchers = [
            new SearcherDefault('Capas Base', () => this.mapBaseLayerGroup),
            new SearcherDefault('Capas', () => this.mapLayers)
        ];
    }
    get oSearcherCollection() {
        return this.mapSearchers;
    }
    get searchControl() {
        return this._searchControl;
    }
    set searchControl(val) {
        this._searchControl = val;
    }
    search(oSearchValue) {
        const subject = new Subject();
        this.oSearcherCollection.forEach(s => s.search(oSearchValue).subscribe(r => {
            if (r.length > 0) {
                subject.next(r);
            }
        }));
        return subject.asObservable();
    }
}

class OMapLayerFactory {
    createMapLayer(layerConf, mapService) {
        let layer;
        switch (layerConf.type) {
            case 'marker':
                layer = this.createMarker(layerConf, mapService);
                break;
            case 'geoJSON':
                layer = this.createGeoJSON(layerConf, mapService);
                break;
            case 'WMS':
                layer = this.createWMS(layerConf, mapService);
                break;
        }
        return layer;
    }
    createMarker(layerConf, mapService) {
        var id = null;
        if (layerConf.layerId) {
            id = layerConf.layerId;
        }
        let layer;
        var success = ((id !== null) && layerConf.center);
        if (success) {
            layer = mapService.addMarker(id, layerConf.center.latitude, layerConf.center.longitude, layerConf.options, layerConf.popup, !layerConf.visible, layerConf.showInMenu, layerConf.menuLabel);
        }
        return layer;
    }
    createGeoJSON(layerConf, mapService) {
        let id = null;
        if (layerConf.layerId) {
            id = layerConf.layerId;
        }
        let layer;
        if (id !== null) {
            if (layerConf.options === undefined) {
                layerConf.options = {};
            }
            layer = mapService.addGeoJSON(id, void 0, layerConf.options, layerConf.popup, !layerConf.visible, layerConf.showInMenu, layerConf.menuLabel, layerConf.contextmenu);
        }
        return layer;
    }
    createWMS(layerConf, mapService) {
        var id = null;
        if (layerConf.layerId) {
            id = layerConf.layerId;
        }
        let opt = {
            format: 'image/png',
            transparent: true
        };
        if (layerConf.options === undefined) {
            layerConf.options = {};
        }
        layerConf.options = Object.assign(layerConf.options, opt);
        let layer;
        var success = (id !== null);
        if (success) {
            layer = mapService.addTileLayerWMS(id, layerConf.baseUrl, layerConf.options, !layerConf.visible, layerConf.showInMenu, layerConf.menuLabel);
        }
        return layer;
    }
}

class LayerConfiguration {
    constructor() {
        this.selected = false;
        this.visible = false;
        this.inWS = false;
    }
}
class LayerConfigurationContextmenu {
    constructor() {
        this.defaultContextmenuItems = true;
    }
}
class LayerConfigurationContextmenuItem {
    constructor() {
        this.defaultContextmenuItems = true;
    }
}

class OToggleIconButtonComponent {
    constructor() {
        this.buttonActive = false;
        this.noInk = false;
    }
    ngOnInit() {
        this.clickable = Util.parseBoolean(this.clickable ? this.clickable.toString() : 'yes', true);
        this.noInk = Util.parseBoolean(this.noInk ? this.noInk.toString() : 'no', false);
        this.noInk = !this.clickable ? true : this.noInk;
        if (this.iconDark === undefined || this.iconDark === null) {
            if (!!this.bgColor) {
                const rgb = this.bgColor.replace(/rgb.*\(/g, '').replace(/[\)\s]/g, '').split(',');
                if (rgb.length >= 3) {
                    this.iconDark = rgb.map(d => parseInt(d, 10) / 255).reduce((n, o) => n + o) / 3 > 0.5;
                }
            }
            else {
                this.iconDark = false;
            }
        }
        else {
            this.iconDark = Util.parseBoolean(this.iconDark.toString(), false);
        }
    }
    toggle() {
        if (this.clickable) {
            return this.buttonActive = !this.buttonActive;
        }
        return false;
    }
    get iconDark() {
        return this._iconDark;
    }
    set iconDark(val) {
        this._iconDark = val;
    }
    get iconName() {
        return this._iconName;
    }
    set iconName(val) {
        this._iconName = val;
    }
}
OToggleIconButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OToggleIconButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OToggleIconButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OToggleIconButtonComponent, selector: "o-toggle-icon-button", inputs: { buttonActive: ["button-active", "buttonActive"], iconDark: ["icon-dark", "iconDark"], iconName: ["icon-name", "iconName"], bgColor: ["bg-color", "bgColor"], clickable: "clickable", noInk: ["no-ink", "noInk"] }, ngImport: i0, template: "<button mat-button *ngIf=\"iconName !== undefined\" [class.active]=\"buttonActive\" [class.dark]=\"iconDark\"\n\t[class.mat-no-ink]=\"noInk\" (click)=\"toggle()\">\n\t<mat-icon>{{ iconName }}</mat-icon>\n</button>", styles: ["button.mdc-button.mat-mdc-button{color:#fff;transition:.35s ease-in-out;opacity:.38;min-width:48px;height:48px;padding:0}button.mdc-button.mat-mdc-button>.mat-icon{margin-right:0;font-size:24px;height:24px;width:24px}button.mdc-button.mat-mdc-button.active{opacity:1}button.mdc-button.mat-mdc-button:hover:after{background-color:#ffffff1f}button.mdc-button.mat-mdc-button.dark{color:#000}button.mdc-button.mat-mdc-button.dark:hover:after{background-color:#0000001f}button.mdc-button.mat-mdc-button.mat-no-ink:hover:after{background:transparent!important}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OToggleIconButtonComponent.prototype, "buttonActive", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OToggleIconButtonComponent.prototype, "clickable", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OToggleIconButtonComponent.prototype, "noInk", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OToggleIconButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-toggle-icon-button', inputs: [
                        'buttonActive: button-active',
                        'iconDark: icon-dark',
                        'iconName: icon-name',
                        'bgColor: bg-color',
                        'clickable',
                        'noInk: no-ink'
                    ], template: "<button mat-button *ngIf=\"iconName !== undefined\" [class.active]=\"buttonActive\" [class.dark]=\"iconDark\"\n\t[class.mat-no-ink]=\"noInk\" (click)=\"toggle()\">\n\t<mat-icon>{{ iconName }}</mat-icon>\n</button>", styles: ["button.mdc-button.mat-mdc-button{color:#fff;transition:.35s ease-in-out;opacity:.38;min-width:48px;height:48px;padding:0}button.mdc-button.mat-mdc-button>.mat-icon{margin-right:0;font-size:24px;height:24px;width:24px}button.mdc-button.mat-mdc-button.active{opacity:1}button.mdc-button.mat-mdc-button:hover:after{background-color:#ffffff1f}button.mdc-button.mat-mdc-button.dark{color:#000}button.mdc-button.mat-mdc-button.dark:hover:after{background-color:#0000001f}button.mdc-button.mat-mdc-button.mat-no-ink:hover:after{background:transparent!important}\n"] }]
        }], propDecorators: { buttonActive: [], clickable: [], noInk: [] } });

class OMapLayerComponent {
    constructor(oMap, injector) {
        this.oMap = oMap;
        this.injector = injector;
        this.selected = false;
        this.visible = true;
        this.inWS = true;
        this.options = {};
        this.oSearchKeys = ['menuLabel', 'menuLabelSecondary'];
        this.rendered = null;
        this._clickEvtEmitter = new EventEmitter();
        this._dblClickEvtEmitter = new EventEmitter();
        this._mouseDownEvtEmitter = new EventEmitter();
        this._mouseUpEvtEmitter = new EventEmitter();
        this._mouseOverEvtEmitter = new EventEmitter();
        this._mouseOutEvtEmitter = new EventEmitter();
        this._mouseMoveEvtEmitter = new EventEmitter();
        this._dragStartEvtEmitter = new EventEmitter();
        this._dragEvtEmitter = new EventEmitter();
        this._dragEndEvtEmitter = new EventEmitter();
        this._resizeEvtEmitter = new EventEmitter();
        this._popupOpenEvtEmitter = new EventEmitter();
        this._popupCloseEvtEmitter = new EventEmitter();
        this._contextmenuEvtEmitter = new EventEmitter();
        this.layerAfterViewInitStream = new EventEmitter();
        this.layerMapConfigured = new EventEmitter();
        this.translateMapService = this.injector.get(TranslateMapService);
        this.layerStream = combineLatest([
            this.layerAfterViewInitStream.asObservable(),
            this.layerMapConfigured.asObservable()
        ]);
        this.layerStreamSubscription = this.layerStream.subscribe(() => {
            if (oMap) {
                this.oMap.addOMapLayer(this);
                this.updateStatus();
            }
        });
        this.oMapConfigurationSubscription = this.oMap.onMapReady().subscribe((map) => {
            if (map) {
                this.layerMapConfigured.emit(true);
            }
        });
    }
    ngOnInit() {
        this.inMenu = this.inMenu ? this.inMenu : 'overlay';
        if (Util.isBlank(this.queryFeaturesInBounds)) {
            this.queryFeaturesInBounds = this.oMap.queryFeaturesInBounds;
        }
    }
    ngAfterViewInit() {
        this.layerAfterViewInitStream.emit(true);
    }
    ngOnDestroy() {
        if (this.oMapConfigurationSubscription) {
            this.oMapConfigurationSubscription.unsubscribe();
        }
        if (this.layerStreamSubscription) {
            this.layerStreamSubscription.unsubscribe();
        }
    }
    getCRSConfigurationParam() {
        return {
            crsConfiguration: this.crsConfiguration,
            crs: this.crs
        };
    }
    get oSearchResult() {
        return {
            label: this.menuLabel,
            sublabel: this.menuLabelSecondary,
            icon: this.icon || 'layers',
            buttons: [{
                    icon: ['check_box', 'check_box_outline_blank'],
                    status: () => this.inWS,
                    callback: () => this.toggleInWS()
                }, {
                    icon: ['visibility', 'visibility_off'],
                    status: () => this.visible,
                    callback: () => this.toggleVisible()
                }]
        };
    }
    getMapService() {
        return this.oMap.getMapService();
    }
    getMapLayerFactory() {
        return new OMapLayerFactory();
    }
    getLayerConfiguration() {
        if (this.layerConf === undefined) {
            this.layerConf = this.createLayerConfiguration();
        }
        return this.layerConf;
    }
    createLayerConfiguration() {
        const layerConf = new LayerConfiguration();
        layerConf.layerId = this.layerId;
        layerConf.type = this.type;
        layerConf.center = this.center;
        layerConf.popup = this.popup;
        layerConf.selected = this.selected;
        layerConf.visible = this.visible;
        layerConf.inWS = this.inWS;
        layerConf.menuLabel = this.menuLabel;
        layerConf.menuLabelSecondary = this.menuLabelSecondary;
        layerConf.service = this.sService;
        layerConf.baseUrl = this.baseUrl;
        layerConf.showInMenu = this.inMenu;
        layerConf.options = this.options;
        layerConf.contextmenu = this.contextMenu;
        return layerConf;
    }
    initializeMapLayer() {
        const self = this;
        if (!this.center && this.sCenter) {
            const coordinates = this.sCenter.split(/,|;/);
            if (coordinates.length === 2) {
                let aux = [];
                for (const i in coordinates) {
                    aux[i] = parseFloat(coordinates[i]);
                }
                this.center = new Center(aux[0], aux[1]);
            }
        }
        if (!this.service && this.sService && this.sService.length > 0) {
            this.service = this.oMap.getInjector().get(this.sService);
        }
        this.layerConf = this.createLayerConfiguration();
        if (this.popupUrl && this.popupUrl.length > 0) {
            this.loadPopupTpl().subscribe(data => {
                self.popup = data;
                self.layerConf.popup = data;
                self.createMapLayer(self.layerConf);
            }, () => {
                console.log('Could not load popup template.');
                self.popup = '';
                self.layerConf.popup = '';
                self.createMapLayer(self.layerConf);
            });
        }
        else {
            self.createMapLayer(self.layerConf);
        }
    }
    createMapLayer(layerConf) {
        const mapService = this.getMapService();
        this.layer = this.getMapLayerFactory().createMapLayer(layerConf, mapService);
        if (Util.isLayerService(this.service) && Util.isGeoJSONLayer(this.layer)) {
            const self = this;
            this.service.load([layerConf]).subscribe(resp => {
                self.layer.addData(resp);
            }, err => {
                console.log(err);
            });
        }
        this.bindLayerEvents();
    }
    setSelected(status) {
        return this.toggleSelected(status);
    }
    toggleSelected(status) {
        this.selected = !Util.isBlank(status) ? status : !this.selected;
        this.updateStatus();
        return this.selected;
    }
    setInWS(status) {
        return this.toggleInWS(status);
    }
    toggleInWS(status) {
        this.inWS = !Util.isBlank(status) ? status : !this.inWS;
        this.updateStatus();
        return this.inWS;
    }
    setVisible(status) {
        return this.toggleVisible(status);
    }
    toggleVisible(status) {
        this.visible = !Util.isBlank(status) ? status : !this.visible;
        this.updateStatus();
        return this.visible;
    }
    setZIndex(i) {
        if (Util.isTileLayer(this.layer)) {
            this.layer.setZIndex(i);
        }
    }
    updateStatus() {
        const mapService = this.getMapService();
        const notCreated = !!this.visible && !!this.inWS && this.rendered === null;
        const createdNotRendered = !!this.visible && !!this.inWS && !this.rendered;
        const renderedNotVisible = !this.visible && !!this.rendered;
        if (notCreated) {
            this.initializeMapLayer();
            this.rendered = true;
        }
        else if (createdNotRendered) {
            mapService.addLayer(this.layerId, this.layer, !this.visible, this.inMenu, this.menuLabel);
            this.rendered = true;
        }
        else if (renderedNotVisible) {
            mapService.removeLayer(this.layerId);
            this.rendered = false;
        }
        this.oMap.mapWorkspace.updateMapLayers();
    }
    bindLayerEvents() {
        const self = this;
        if (Util.isTileLayer(this.layer)) {
            this.layer.on('click', (evt) => {
                self._clickEvtEmitter.emit(evt);
            });
            this.layer.on('dblclick', (evt) => {
                self._dblClickEvtEmitter.emit(evt);
            });
            this.layer.on('mousedown', (evt) => {
                self._mouseDownEvtEmitter.emit(evt);
            });
            this.layer.on('mouseup', (evt) => {
                self._mouseUpEvtEmitter.emit(evt);
            });
            this.layer.on('mouseover', (evt) => {
                self._mouseOverEvtEmitter.emit(evt);
            });
            this.layer.on('mouseout', (evt) => {
                self._mouseOutEvtEmitter.emit(evt);
            });
            this.layer.on('mousemove', (evt) => {
                self._mouseMoveEvtEmitter.emit(evt);
            });
            this.layer.on('dragstart', (evt) => {
                self._dragStartEvtEmitter.emit(evt);
            });
            this.layer.on('drag', (evt) => {
                self._dragEvtEmitter.emit(evt);
            });
            this.layer.on('dragend', (evt) => {
                self._dragEndEvtEmitter.emit(evt);
            });
            this.layer.on('resize', (evt) => {
                self._resizeEvtEmitter.emit(evt);
            });
            this.layer.on('popupopen', (evt) => {
                self._popupOpenEvtEmitter.emit(evt);
            });
            this.layer.on('popupclose', (evt) => {
                self._popupCloseEvtEmitter.emit(evt);
            });
            this.layer.on('contextmenu', (evt) => {
                self._contextmenuEvtEmitter.emit(evt);
            });
            if (this.queryFeaturesInBounds) {
                this.oMap.getMapService().map.on('moveend', () => {
                    if (self.visible && Util.isLayerService(self.service) && Util.isGeoJSONLayer(self.layer)) {
                        self.service.load([self.layerConf]).subscribe((resp) => {
                            self.layer.clearLayers();
                            self.layer.addData(resp);
                        }, (err) => {
                            console.log(err);
                        });
                    }
                });
            }
        }
    }
    onClickEvent(onNext) {
        return this._clickEvtEmitter.subscribe(onNext);
    }
    onDoubleClickEvent(onNext) {
        return this._dblClickEvtEmitter.subscribe(onNext);
    }
    onMouseDownEvent(onNext) {
        return this._mouseDownEvtEmitter.subscribe(onNext);
    }
    onMouseUpEvent(onNext) {
        return this._mouseUpEvtEmitter.subscribe(onNext);
    }
    onMouseOverEvent(onNext) {
        return this._mouseOverEvtEmitter.subscribe(onNext);
    }
    onMouseOutEvent(onNext) {
        return this._mouseOutEvtEmitter.subscribe(onNext);
    }
    onMouseMoveEvent(onNext) {
        return this._mouseMoveEvtEmitter.subscribe(onNext);
    }
    onDragStartEvent(onNext) {
        return this._dragStartEvtEmitter.subscribe(onNext);
    }
    onDragEvent(onNext) {
        return this._dragEvtEmitter.subscribe(onNext);
    }
    onDragEndEvent(onNext) {
        return this._dragEndEvtEmitter.subscribe(onNext);
    }
    onResizeEvent(onNext) {
        return this._resizeEvtEmitter.subscribe(onNext);
    }
    onPopupCloseEvent(onNext) {
        return this._popupCloseEvtEmitter.subscribe(onNext);
    }
    onPopupOpenEvent(onNext) {
        return this._popupOpenEvtEmitter.subscribe(onNext);
    }
    loadPopupTpl() {
        const headers = new Headers();
        headers.append('Access-Control-Allow-Origin', '*');
        const httpClient = this.injector.get(HttpClient);
        return httpClient.get(this.popupUrl)
            .pipe(map((response) => response.text()));
    }
    get layerId() {
        return this._layerId;
    }
    set layerId(val) {
        this._layerId = val;
    }
    get icon() {
        return (this._icon && this._icon.length) ? this._icon : 'layers';
    }
    set icon(val) {
        this._icon = val;
    }
    get menuLabelSecondary() {
        return this._menuLabelSecondary;
    }
    set menuLabelSecondary(val) {
        this._menuLabelSecondary = val;
    }
    get menuLabel() {
        return this._menuLabel;
    }
    set menuLabel(val) {
        this._menuLabel = val;
    }
    set contextMenu(val) {
        if (!val) {
            return;
        }
        this._contextmenu = val;
        if (val.defaultContextmenuItems) {
            this._contextmenu.contextmenuItems =
                this._contextmenu.contextmenuItems.concat(this.getMapService().defaultContextMenu.contextmenuItems);
        }
        if (!this._contextmenu.contextmenuItems) {
            return;
        }
        this._contextmenu.contextmenuItems = this.getMapService().parseContextmenuItems(this._contextmenu.contextmenuItems);
    }
    get contextMenu() {
        return this._contextmenu;
    }
}
OMapLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerComponent, deps: [{ token: forwardRef(() => OMapBase$1) }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
OMapLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapLayerComponent, selector: "o-map-layer", inputs: { sCenter: ["layer-center", "sCenter"], sPoints: ["layer-points", "sPoints"], sRadius: ["layer-radius", "sRadius"], sBounds: ["layer-bounds", "sBounds"], sService: ["layer-service", "sService"], baseUrl: ["layer-base-url", "baseUrl"], selected: ["layer-selected", "selected"], visible: ["layer-visible", "visible"], inWS: ["layer-in-ws", "inWS"], inMenu: ["layer-in-menu", "inMenu"], layerId: ["layer-id", "layerId"], layerGroupId: ["layer-group-id", "layerGroupId"], type: ["layer-type", "type"], popup: ["layer-popup", "popup"], popupUrl: ["layer-popup-url", "popupUrl"], menuLabel: ["layer-menu-label", "menuLabel"], menuLabelSecondary: ["layer-menu-label-secondary", "menuLabelSecondary"], icon: ["layer-icon", "icon"], options: ["layer-options", "options"], crs: "crs", crsConfiguration: ["crs-configuration", "crsConfiguration"], contextMenu: ["layer-contextmenu", "contextMenu"], queryFeaturesInBounds: ["query-features-in-bounds", "queryFeaturesInBounds"] }, host: { properties: { "class.o-map-layer": "true" } }, providers: [MapService], ngImport: i0, template: "<button mat-button mat-ink #layer class=\"o-map-layer-item\" (click)=\"toggleInWS()\">\n\t<!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\" [src]=\"icon\">-->\n\t<o-toggle-icon-button icon-dark=\"true\" [icon-name]=\"icon\" [button-active]=\"inWS\">\n\t</o-toggle-icon-button>\n\t<div fxFlex fxLayout=\"column\" fxLayoutAlign=\"center start\">\n\t\t{{menuLabel || layerId}}\n\t\t<small *ngIf=\"menuLabelSecondary !== undefined\">{{menuLabelSecondary}}</small>\n\t</div>\n</button>", styles: [".o-map-layer>button .mdc-button__ripple{display:none}.o-map-layer>button o-toggle-icon-button .mdc-button__ripple{display:none}.o-map-layer button.o-map-layer-item{font-size:.8em;visibility:initial;width:100%;padding:0;display:flex;line-height:normal;overflow:hidden}.o-map-layer button.o-map-layer-item>span{display:flex;box-sizing:border-box;flex-direction:row;width:100%}.o-map-layer .layer-icon{height:24px;width:24px;margin:15px 4px 15px 0}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.DefaultFlexDirective, selector: "  [fxFlex], [fxFlex.xs], [fxFlex.sm], [fxFlex.md],  [fxFlex.lg], [fxFlex.xl], [fxFlex.lt-sm], [fxFlex.lt-md],  [fxFlex.lt-lg], [fxFlex.lt-xl], [fxFlex.gt-xs], [fxFlex.gt-sm],  [fxFlex.gt-md], [fxFlex.gt-lg]", inputs: ["fxFlex", "fxFlex.xs", "fxFlex.sm", "fxFlex.md", "fxFlex.lg", "fxFlex.xl", "fxFlex.lt-sm", "fxFlex.lt-md", "fxFlex.lt-lg", "fxFlex.lt-xl", "fxFlex.gt-xs", "fxFlex.gt-sm", "fxFlex.gt-md", "fxFlex.gt-lg"] }, { kind: "component", type: OToggleIconButtonComponent, selector: "o-toggle-icon-button", inputs: ["button-active", "icon-dark", "icon-name", "bg-color", "clickable", "no-ink"] }], encapsulation: i0.ViewEncapsulation.None });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapLayerComponent.prototype, "selected", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapLayerComponent.prototype, "visible", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapLayerComponent.prototype, "inWS", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapLayerComponent.prototype, "queryFeaturesInBounds", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-layer', providers: [MapService], inputs: [
                        'sCenter : layer-center',
                        'sPoints : layer-points',
                        'sRadius : layer-radius',
                        'sBounds : layer-bounds',
                        'sService : layer-service',
                        'baseUrl  : layer-base-url',
                        'selected : layer-selected',
                        'visible : layer-visible',
                        'inWS : layer-in-ws',
                        'inMenu : layer-in-menu',
                        'layerId : layer-id',
                        'layerGroupId : layer-group-id',
                        'type : layer-type',
                        'popup : layer-popup',
                        'popupUrl : layer-popup-url',
                        'menuLabel : layer-menu-label',
                        'menuLabelSecondary : layer-menu-label-secondary',
                        'icon : layer-icon',
                        'options : layer-options',
                        'crs',
                        'crsConfiguration : crs-configuration',
                        'contextMenu : layer-contextmenu',
                        'queryFeaturesInBounds: query-features-in-bounds'
                    ], encapsulation: ViewEncapsulation.None, host: {
                        '[class.o-map-layer]': 'true'
                    }, template: "<button mat-button mat-ink #layer class=\"o-map-layer-item\" (click)=\"toggleInWS()\">\n\t<!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\" [src]=\"icon\">-->\n\t<o-toggle-icon-button icon-dark=\"true\" [icon-name]=\"icon\" [button-active]=\"inWS\">\n\t</o-toggle-icon-button>\n\t<div fxFlex fxLayout=\"column\" fxLayoutAlign=\"center start\">\n\t\t{{menuLabel || layerId}}\n\t\t<small *ngIf=\"menuLabelSecondary !== undefined\">{{menuLabelSecondary}}</small>\n\t</div>\n</button>", styles: [".o-map-layer>button .mdc-button__ripple{display:none}.o-map-layer>button o-toggle-icon-button .mdc-button__ripple{display:none}.o-map-layer button.o-map-layer-item{font-size:.8em;visibility:initial;width:100%;padding:0;display:flex;line-height:normal;overflow:hidden}.o-map-layer button.o-map-layer-item>span{display:flex;box-sizing:border-box;flex-direction:row;width:100%}.o-map-layer .layer-icon{height:24px;width:24px;margin:15px 4px 15px 0}\n"] }]
        }], ctorParameters: function () {
        return [{ type: OMapBase$1, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapBase$1)]
                    }] }, { type: i0.Injector }];
    }, propDecorators: { selected: [], visible: [], inWS: [], queryFeaturesInBounds: [] } });

class OMapLayerGroupComponent {
    constructor(oMap) {
        this.oMap = oMap;
        this.collapsed = false;
        this.mapLayers = [];
        this.mLayerGroupsWarehouse = new OMapLayerGroupsWarehouse();
    }
    ngOnInit() {
        if (!!this.refGroup) {
            this.mapLayers = this.refGroup.mapLayers;
            this.mLayerGroupsWarehouse = this.refGroup.layerGroupsWarehouse;
        }
    }
    hasChildInWS() {
        let childLayerGroupInWS = false;
        if (this.layerGroupChildren) {
            this.layerGroupChildren.forEach(lg => {
                if (lg.hasChildInWS()) {
                    childLayerGroupInWS = true;
                }
            });
        }
        let childLayerInWS = false;
        if (this.layerChildren) {
            this.layerChildren.forEach(l => {
                if (l.inWS) {
                    childLayerInWS = true;
                }
            });
        }
        return childLayerGroupInWS || childLayerInWS;
    }
    getMapLayers() {
        return this.mapLayers;
    }
    getLayerGroups() {
        if (this.mLayerGroupsWarehouse.all &&
            this.mLayerGroupsWarehouse.all.length > 0) {
            return this.mLayerGroupsWarehouse.all;
        }
        return [];
    }
    getLayerCenter(layerConf) {
        let center;
        if (layerConf && layerConf.center) {
            center = layerConf.center.latitude + ';' + layerConf.center.longitude;
        }
        return center;
    }
    toggleCollapse() {
        this.collapsed = !this.collapsed;
    }
    get description() {
        return this._description;
    }
    set description(val) {
        this._description = val;
    }
}
OMapLayerGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerGroupComponent, deps: [{ token: forwardRef(() => OMapBase$1) }], target: i0.ɵɵFactoryTarget.Component });
OMapLayerGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapLayerGroupComponent, selector: "o-map-layer-group", inputs: { id: ["group-id", "id"], idParent: ["group-id-parent", "idParent"], name: ["group-name", "name"], description: ["group-description", "description"], collapsed: ["group-collapsed", "collapsed"], refGroup: ["group-ref", "refGroup"] }, host: { properties: { "class.o-map-layer-group": "true" } }, providers: [], viewQueries: [{ propertyName: "layerChildren", predicate: i0.forwardRef(function () { return OMapLayerComponent; }), descendants: true }, { propertyName: "layerGroupChildren", predicate: i0.forwardRef(function () { return OMapLayerGroupComponent; }), descendants: true }], ngImport: i0, template: "<button mat-button mat-ink fxFlex fxFlexFill [class.collapsed]= \"collapsed\"\n\t*ngIf=\"description !== undefined && description.length > 0\"\n\tfxLayout=\"row\" fxLayoutAlign=\"space-around center\"\n\t(click)=\"toggleCollapse()\">\n\t<!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\"[src]= \"icon\">-->\n\t<o-toggle-icon-button\n\t\tclickable=\"no\"\n\t\ticon-dark=\"true\"\n\t\ticon-name=\"folder\"\n\t\t[button-active]= \"hasChildInWS()\">\n\t</o-toggle-icon-button>\n\t<span fxFlex fxLayout=\"row\" fxLayoutAlign=\"start center\">{{ description }}</span>\n\t<o-toggle-icon-button\n\t\tclickable=\"no\" icon-dark=\"true\"\ticon-name=\"keyboard_arrow_down\">\n\t</o-toggle-icon-button>\n</button>\n<div class=\"group-list\" [class.collapsed]= \"collapsed\" [class.expanded]= \"!collapsed\"\n\tfxFlex fxLayout=\"column\" fxLayoutAlign=\"space-between stretch\">\n\t<!-- ng-if=\"mapLayerGroups.all && mapLayerGroups.all.length > 0 \" fxFlex-->\n\t<o-map-layer-group\n\t\t*ngFor=\"let layerGroup of getLayerGroups()\"\n\t\t[group-id]          = \"layerGroup.id\"\n\t\t[group-id-parent]   = \"layerGroup.idParent\"\n\t\t[group-name]        = \"layerGroup.name\"\n\t\t[group-description] = \"layerGroup.description\"\n    [group-collapsed]   = \"layerGroup.collapsed\"\n\t\t[group-ref]         = \"layerGroup\">\n  </o-map-layer-group>\n  <!-- ng-if=\"mapLayers && mapLayers.length > 0\" -->\n\t<o-map-layer fxFlex\n    *ngFor=\"let layerConf of getMapLayers()\"\n\t\t[layer-radius]                = \"layerConf.radius\"\n\t\t[layer-service]               = \"layerConf.service\"\n\t\t[layer-base-url]              = \"layerConf.baseUrl\"\n\t\t[layer-selected]              = \"layerConf.selected\"\n\t\t[layer-visible]               = \"layerConf.visible\"\n\t\t[layer-in-ws]                 = \"layerConf.inWS\"\n\t\t[layer-id]                    = \"layerConf.layerId\"\n\t\t[layer-group-id]              = \"layerConf.layerGroupId\"\n\t\t[layer-type]                  = \"layerConf.type\"\n\t\t[layer-popup]                 = \"layerConf.popup\"\n\t\t[layer-popup-url]             = \"layerConf.popupUrl\"\n\t\t[layer-menu-label]            = \"layerConf.menuLabel\"\n\t\t[layer-menu-label-secondary]  = \"layerConf.menuLabelSecondary\"\n\t\t[layer-icon]                  = \"layerConf.icon\"\n\t\t[layer-show-in-menu]          = \"layerConf.showInMenu\"\n\t\t[layer-center]                = \"getLayerCenter(layerConf)\"\n\t\t[layer-options]               = \"layerConf.options\">\n\t</o-map-layer>\n</div>\n<!--\n\tTODO\n\t\t[layer-points]\t\t\t\t\t= \"layer.points\"\n\t\t[layer-bounds]\t\t\t\t\t= \"layer.bounds\"\n\t\t[layer-options]\t\t\t\t\t= \"layer.options\"\n-->\n", styles: [".o-map-layer-group{overflow:auto;width:100%;min-width:100%;display:inline-block!important}.o-map-layer-group .group-list.expanded{width:100%;min-width:100%;display:inline-block!important}.o-map-layer-group button{width:100%;padding:0;display:flex;line-height:normal;overflow:hidden}.o-map-layer-group button [icon-name=keyboard_arrow_down]{transition:all .35s cubic-bezier(.55,0,.55,1);transform:rotate(180deg)}.o-map-layer-group button.collapsed [icon-name=keyboard_arrow_down]{transform:rotate(0)}.o-map-layer-group .group-list{transition:max-height .35s cubic-bezier(.55,0,.55,1);max-height:1000px;padding-left:0;overflow:hidden}.o-map-layer-group .group-list.collapsed{transition:max-height .35s cubic-bezier(.55,0,.55,1);max-height:0px}.o-map-layer-group .group-list.expanded{border-top:1px solid #eee;border-bottom:1px solid #eee;box-sizing:initial!important}.o-map-layer-group .group-list.expanded button+.group-list.expanded button{padding-left:10px}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.FlexFillDirective, selector: "[fxFill], [fxFlexFill]" }, { kind: "directive", type: i3$1.DefaultFlexDirective, selector: "  [fxFlex], [fxFlex.xs], [fxFlex.sm], [fxFlex.md],  [fxFlex.lg], [fxFlex.xl], [fxFlex.lt-sm], [fxFlex.lt-md],  [fxFlex.lt-lg], [fxFlex.lt-xl], [fxFlex.gt-xs], [fxFlex.gt-sm],  [fxFlex.gt-md], [fxFlex.gt-lg]", inputs: ["fxFlex", "fxFlex.xs", "fxFlex.sm", "fxFlex.md", "fxFlex.lg", "fxFlex.xl", "fxFlex.lt-sm", "fxFlex.lt-md", "fxFlex.lt-lg", "fxFlex.lt-xl", "fxFlex.gt-xs", "fxFlex.gt-sm", "fxFlex.gt-md", "fxFlex.gt-lg"] }, { kind: "component", type: OMapLayerComponent, selector: "o-map-layer", inputs: ["layer-center", "layer-points", "layer-radius", "layer-bounds", "layer-service", "layer-base-url", "layer-selected", "layer-visible", "layer-in-ws", "layer-in-menu", "layer-id", "layer-group-id", "layer-type", "layer-popup", "layer-popup-url", "layer-menu-label", "layer-menu-label-secondary", "layer-icon", "layer-options", "crs", "crs-configuration", "layer-contextmenu", "query-features-in-bounds"] }, { kind: "component", type: OMapLayerGroupComponent, selector: "o-map-layer-group", inputs: ["group-id", "group-id-parent", "group-name", "group-description", "group-collapsed", "group-ref"] }, { kind: "component", type: OToggleIconButtonComponent, selector: "o-toggle-icon-button", inputs: ["button-active", "icon-dark", "icon-name", "bg-color", "clickable", "no-ink"] }], encapsulation: i0.ViewEncapsulation.None });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapLayerGroupComponent.prototype, "collapsed", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapLayerGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-layer-group', providers: [], inputs: [
                        'id: group-id',
                        'idParent: group-id-parent',
                        'name: group-name',
                        'description: group-description',
                        'collapsed: group-collapsed',
                        'refGroup: group-ref'
                    ], encapsulation: ViewEncapsulation.None, host: {
                        '[class.o-map-layer-group]': 'true'
                    }, template: "<button mat-button mat-ink fxFlex fxFlexFill [class.collapsed]= \"collapsed\"\n\t*ngIf=\"description !== undefined && description.length > 0\"\n\tfxLayout=\"row\" fxLayoutAlign=\"space-around center\"\n\t(click)=\"toggleCollapse()\">\n\t<!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\"[src]= \"icon\">-->\n\t<o-toggle-icon-button\n\t\tclickable=\"no\"\n\t\ticon-dark=\"true\"\n\t\ticon-name=\"folder\"\n\t\t[button-active]= \"hasChildInWS()\">\n\t</o-toggle-icon-button>\n\t<span fxFlex fxLayout=\"row\" fxLayoutAlign=\"start center\">{{ description }}</span>\n\t<o-toggle-icon-button\n\t\tclickable=\"no\" icon-dark=\"true\"\ticon-name=\"keyboard_arrow_down\">\n\t</o-toggle-icon-button>\n</button>\n<div class=\"group-list\" [class.collapsed]= \"collapsed\" [class.expanded]= \"!collapsed\"\n\tfxFlex fxLayout=\"column\" fxLayoutAlign=\"space-between stretch\">\n\t<!-- ng-if=\"mapLayerGroups.all && mapLayerGroups.all.length > 0 \" fxFlex-->\n\t<o-map-layer-group\n\t\t*ngFor=\"let layerGroup of getLayerGroups()\"\n\t\t[group-id]          = \"layerGroup.id\"\n\t\t[group-id-parent]   = \"layerGroup.idParent\"\n\t\t[group-name]        = \"layerGroup.name\"\n\t\t[group-description] = \"layerGroup.description\"\n    [group-collapsed]   = \"layerGroup.collapsed\"\n\t\t[group-ref]         = \"layerGroup\">\n  </o-map-layer-group>\n  <!-- ng-if=\"mapLayers && mapLayers.length > 0\" -->\n\t<o-map-layer fxFlex\n    *ngFor=\"let layerConf of getMapLayers()\"\n\t\t[layer-radius]                = \"layerConf.radius\"\n\t\t[layer-service]               = \"layerConf.service\"\n\t\t[layer-base-url]              = \"layerConf.baseUrl\"\n\t\t[layer-selected]              = \"layerConf.selected\"\n\t\t[layer-visible]               = \"layerConf.visible\"\n\t\t[layer-in-ws]                 = \"layerConf.inWS\"\n\t\t[layer-id]                    = \"layerConf.layerId\"\n\t\t[layer-group-id]              = \"layerConf.layerGroupId\"\n\t\t[layer-type]                  = \"layerConf.type\"\n\t\t[layer-popup]                 = \"layerConf.popup\"\n\t\t[layer-popup-url]             = \"layerConf.popupUrl\"\n\t\t[layer-menu-label]            = \"layerConf.menuLabel\"\n\t\t[layer-menu-label-secondary]  = \"layerConf.menuLabelSecondary\"\n\t\t[layer-icon]                  = \"layerConf.icon\"\n\t\t[layer-show-in-menu]          = \"layerConf.showInMenu\"\n\t\t[layer-center]                = \"getLayerCenter(layerConf)\"\n\t\t[layer-options]               = \"layerConf.options\">\n\t</o-map-layer>\n</div>\n<!--\n\tTODO\n\t\t[layer-points]\t\t\t\t\t= \"layer.points\"\n\t\t[layer-bounds]\t\t\t\t\t= \"layer.bounds\"\n\t\t[layer-options]\t\t\t\t\t= \"layer.options\"\n-->\n", styles: [".o-map-layer-group{overflow:auto;width:100%;min-width:100%;display:inline-block!important}.o-map-layer-group .group-list.expanded{width:100%;min-width:100%;display:inline-block!important}.o-map-layer-group button{width:100%;padding:0;display:flex;line-height:normal;overflow:hidden}.o-map-layer-group button [icon-name=keyboard_arrow_down]{transition:all .35s cubic-bezier(.55,0,.55,1);transform:rotate(180deg)}.o-map-layer-group button.collapsed [icon-name=keyboard_arrow_down]{transform:rotate(0)}.o-map-layer-group .group-list{transition:max-height .35s cubic-bezier(.55,0,.55,1);max-height:1000px;padding-left:0;overflow:hidden}.o-map-layer-group .group-list.collapsed{transition:max-height .35s cubic-bezier(.55,0,.55,1);max-height:0px}.o-map-layer-group .group-list.expanded{border-top:1px solid #eee;border-bottom:1px solid #eee;box-sizing:initial!important}.o-map-layer-group .group-list.expanded button+.group-list.expanded button{padding-left:10px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: OMapBase$1, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapBase$1)]
                    }] }];
    }, propDecorators: { collapsed: [], layerChildren: [{
                type: ViewChildren,
                args: [forwardRef(() => OMapLayerComponent)]
            }], layerGroupChildren: [{
                type: ViewChildren,
                args: [forwardRef(() => OMapLayerGroupComponent)]
            }] } });

class OMapWorkspaceBase {
}

class OMapWorkspaceLayerComponent {
    constructor(refWorkspace) {
        this.refWorkspace = refWorkspace;
        this.selected = false;
        this.visible = true;
        this.inWS = true;
        this.dragging = false;
        this.oSearchKeys = ['menuLabel', 'menuLabelSecondary'];
        this.onToggleSelected = new EventEmitter();
        this.onToggleVisibility = new EventEmitter();
        this.onToggleInWS = new EventEmitter();
    }
    get oSearchResult() {
        return {
            label: this.menuLabel,
            sublabel: this.menuLabelSecondary,
            icon: 'layer',
            buttons: []
        };
    }
    toggleSelected(status) {
        const select = (status !== undefined && !!status) || (!!this.visible && !!this.inWS);
        const unselect = (status !== undefined && !status) || !this.selected;
        if (select) {
            this.refWorkspace.oSearchableCollection.forEach(l => l.setSelected(false));
            this.selected = this.refLayer.toggleSelected();
        }
        else if (unselect) {
            this.selected = this.refLayer.setSelected(false);
        }
        this.onToggleSelected.emit(this);
    }
    toggleVisible(status, evt, avoidEvent) {
        if (evt) {
            evt.stopPropagation();
        }
        this.visible = this.refLayer.toggleVisible(status);
        if (!this.visible && !!this.selected) {
            this.toggleSelected(false);
        }
        if (!avoidEvent) {
            this.onToggleVisibility.emit(this);
        }
    }
    toggleInWS(status) {
        this.inWS = this.refLayer.toggleInWS(status);
        if (!this.inWS && !!this.visible) {
            this.toggleVisible(false, undefined, true);
        }
        this.onToggleInWS.emit(this);
    }
    get menuLabel() {
        return this._menuLabel;
    }
    set menuLabel(val) {
        this._menuLabel = val;
    }
    get menuLabelSecondary() {
        return this._menuLabelSecondary;
    }
    set menuLabelSecondary(val) {
        this._menuLabelSecondary = val;
    }
}
OMapWorkspaceLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapWorkspaceLayerComponent, deps: [{ token: forwardRef(() => OMapWorkspaceBase) }], target: i0.ɵɵFactoryTarget.Component });
OMapWorkspaceLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapWorkspaceLayerComponent, selector: "o-map-workspace-layer", inputs: { selected: ["layer-selected", "selected"], visible: ["layer-visible", "visible"], inWS: ["layer-in-ws", "inWS"], menuLabel: ["layer-menu-label", "menuLabel"], menuLabelSecondary: ["layer-menu-label-secondary", "menuLabelSecondary"], refLayer: ["layer-ref", "refLayer"], layerIndex: ["layer-index", "layerIndex"] }, outputs: { onToggleSelected: "onToggleSelected", onToggleVisibility: "onToggleVisibility", onToggleInWS: "onToggleInWS" }, host: { properties: { "class.o-map-workspace-layer": "true" } }, providers: [], ngImport: i0, template: "<div class=\"mat-content\" fxLayout=\"row\" fxLayoutAlign=\"start stretch\" [class.selected]=\"selected\" (click)=\"toggleSelected()\">\n\n  <o-toggle-icon-button clickable=\"no\" icon-dark=\"true\" icon-name=\"drag_handle\" class=\"drag-handle\">\n  </o-toggle-icon-button>\n  <!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\" [src]=\"icon\">-->\n  <div fxFlex>{{ menuLabel }}\n    <small *ngIf=\"menuLabelSecondary\">\n      <br>{{ menuLabelSecondary }}</small>\n  </div>\n  <o-toggle-icon-button icon-dark=\"true\" [icon-name]=\"visible ? 'visibility' : 'visibility_off'\" [button-active]=\"visible\"\n    (click)=\"toggleVisible(undefined, $event)\">\n  </o-toggle-icon-button>\n  <o-toggle-icon-button icon-dark=\"true\" icon-name=\"delete\" [button-active]=\"inWS\" (click)=\"toggleInWS()\">\n  </o-toggle-icon-button>\n</div>", styles: [".o-map-workspace-layer{opacity:1;display:block}.o-map-workspace-layer>div{position:relative;padding:8px;margin:0;box-shadow:0 0;border-radius:0;border-width:0px;transition:.35s;border:0px solid rgba(200,200,200,.38)}.o-map-workspace-layer>div.selected{background:rgba(0,0,0,.2)}.o-map-workspace-layer.cdk-drag-placeholder{opacity:0}.o-map-workspace-layer.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.o-map-workspace-layer.cdk-drag-preview .mat-content{margin:0 8px 8px;box-shadow:0 4px 8px -4px;border-radius:4px;border-width:1px}.o-map-workspace-layer.cdk-drag-preview .mat-content o-toggle-icon-button{display:none}.o-map-workspace-layer.cdk-drag-preview .mat-content o-toggle-icon-button.drag-handle{display:initial}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.DefaultFlexDirective, selector: "  [fxFlex], [fxFlex.xs], [fxFlex.sm], [fxFlex.md],  [fxFlex.lg], [fxFlex.xl], [fxFlex.lt-sm], [fxFlex.lt-md],  [fxFlex.lt-lg], [fxFlex.lt-xl], [fxFlex.gt-xs], [fxFlex.gt-sm],  [fxFlex.gt-md], [fxFlex.gt-lg]", inputs: ["fxFlex", "fxFlex.xs", "fxFlex.sm", "fxFlex.md", "fxFlex.lg", "fxFlex.xl", "fxFlex.lt-sm", "fxFlex.lt-md", "fxFlex.lt-lg", "fxFlex.lt-xl", "fxFlex.gt-xs", "fxFlex.gt-sm", "fxFlex.gt-md", "fxFlex.gt-lg"] }, { kind: "component", type: OToggleIconButtonComponent, selector: "o-toggle-icon-button", inputs: ["button-active", "icon-dark", "icon-name", "bg-color", "clickable", "no-ink"] }], encapsulation: i0.ViewEncapsulation.None });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapWorkspaceLayerComponent.prototype, "selected", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapWorkspaceLayerComponent.prototype, "visible", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapWorkspaceLayerComponent.prototype, "inWS", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapWorkspaceLayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-workspace-layer', providers: [], inputs: [
                        'selected : layer-selected',
                        'visible : layer-visible',
                        'inWS : layer-in-ws',
                        'menuLabel : layer-menu-label',
                        'menuLabelSecondary : layer-menu-label-secondary',
                        'refLayer : layer-ref',
                        'layerIndex : layer-index'
                    ], outputs: [
                        'onToggleSelected',
                        'onToggleVisibility',
                        'onToggleInWS'
                    ], encapsulation: ViewEncapsulation.None, host: {
                        '[class.o-map-workspace-layer]': 'true'
                    }, template: "<div class=\"mat-content\" fxLayout=\"row\" fxLayoutAlign=\"start stretch\" [class.selected]=\"selected\" (click)=\"toggleSelected()\">\n\n  <o-toggle-icon-button clickable=\"no\" icon-dark=\"true\" icon-name=\"drag_handle\" class=\"drag-handle\">\n  </o-toggle-icon-button>\n  <!--<img class=\"layer-icon\" *ngIf=\"icon && icon.length>0\" [src]=\"icon\">-->\n  <div fxFlex>{{ menuLabel }}\n    <small *ngIf=\"menuLabelSecondary\">\n      <br>{{ menuLabelSecondary }}</small>\n  </div>\n  <o-toggle-icon-button icon-dark=\"true\" [icon-name]=\"visible ? 'visibility' : 'visibility_off'\" [button-active]=\"visible\"\n    (click)=\"toggleVisible(undefined, $event)\">\n  </o-toggle-icon-button>\n  <o-toggle-icon-button icon-dark=\"true\" icon-name=\"delete\" [button-active]=\"inWS\" (click)=\"toggleInWS()\">\n  </o-toggle-icon-button>\n</div>", styles: [".o-map-workspace-layer{opacity:1;display:block}.o-map-workspace-layer>div{position:relative;padding:8px;margin:0;box-shadow:0 0;border-radius:0;border-width:0px;transition:.35s;border:0px solid rgba(200,200,200,.38)}.o-map-workspace-layer>div.selected{background:rgba(0,0,0,.2)}.o-map-workspace-layer.cdk-drag-placeholder{opacity:0}.o-map-workspace-layer.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.o-map-workspace-layer.cdk-drag-preview .mat-content{margin:0 8px 8px;box-shadow:0 4px 8px -4px;border-radius:4px;border-width:1px}.o-map-workspace-layer.cdk-drag-preview .mat-content o-toggle-icon-button{display:none}.o-map-workspace-layer.cdk-drag-preview .mat-content o-toggle-icon-button.drag-handle{display:initial}\n"] }]
        }], ctorParameters: function () {
        return [{ type: OMapWorkspaceBase, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapWorkspaceBase)]
                    }] }];
    }, propDecorators: { selected: [], visible: [], inWS: [] } });

class OMapWorkspaceComponent {
    get oSearchableCollection() {
        return this.wsMapLayers;
    }
    constructor(map) {
        this.map = map;
        this.wsMapLayers = new Array();
        this.oSearchTitle = 'Capas del Espacio de Trabajo';
        this.oSearcherCollection = null;
        this.onToggleWSLayerSelected = new EventEmitter();
        this.onToggleWSLayerVisibility = new EventEmitter();
        this.onToggleWSLayerInWS = new EventEmitter();
    }
    parentHasDragHandle(element) {
        let result = false;
        let parent = element.parentNode;
        let i = 0;
        while (i <= 2) {
            i++;
            result = parent && parent.classList.contains('drag-handle');
            if (result) {
                break;
            }
            parent = parent.parentNode;
        }
        return result;
    }
    search(_oSearchValue) {
        const subject = new Subject();
        setTimeout(() => subject.next(this.oSearchableCollection), 1);
        return subject.asObservable();
    }
    updateMapLayer(l) {
        const p = this.wsMapLayers.indexOf(l);
        const inML = p > -1;
        const inWS = l.inWS === true;
        if (inWS && !inML) {
            this.wsMapLayers.push(l);
            this.updateMapLayersPosition();
        }
        else if (!inWS && inML) {
            this.wsMapLayers.splice(p, 1);
        }
    }
    onListitemDragDrop(event) {
        moveItemInArray(this.oSearchableCollection, event.previousIndex, event.currentIndex);
        this.updateMapLayersPosition();
    }
    updateMapLayers() {
        this.map.getOMapLayers().forEach(l => this.updateMapLayer(l));
    }
    getSelectedMapLayer() {
        return this.wsMapLayers.filter(l => l.selected === true)[0];
    }
    getMapLayers() {
        return this.wsMapLayers;
    }
    onWSLayerSelected(event) {
        this.onToggleWSLayerSelected.emit(event);
    }
    onWSLayerVisibilityToggled(event) {
        this.onToggleWSLayerVisibility.emit(event);
    }
    onWSLayerInWSToggled(event) {
        this.onToggleWSLayerInWS.emit(event);
    }
    updateMapLayersPosition() {
        const zMax = this.wsMapLayers.length;
        this.wsMapLayers.forEach((l, i) => {
            l.setZIndex(zMax - i + 2);
        });
    }
}
OMapWorkspaceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapWorkspaceComponent, deps: [{ token: forwardRef(() => OMapBase$1) }], target: i0.ɵɵFactoryTarget.Component });
OMapWorkspaceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapWorkspaceComponent, selector: "o-map-workspace", outputs: { onToggleWSLayerSelected: "onToggleWSLayerSelected", onToggleWSLayerVisibility: "onToggleWSLayerVisibility", onToggleWSLayerInWS: "onToggleWSLayerInWS" }, host: { properties: { "class.o-map-workspace": "true" } }, providers: [
        { provide: OMapWorkspaceBase, useExisting: forwardRef(() => OMapWorkspaceComponent) }
    ], ngImport: i0, template: "<div cdkDropList (cdkDropListDropped)=\"onListitemDragDrop($event)\">\n\t<o-map-workspace-layer *ngFor=\"let layer of oSearchableCollection; let x = index\" cdkDrag\n\t\t[layer-index]\t\t\t\t\t\t\t\t\t= \"x\"\n\t\t[layer-selected]              = \"layer.selected\"\n\t\t[layer-visible]               = \"layer.visible\"\n\t\t[layer-in-ws]                 = \"layer.inWS\"\n\t\t[layer-menu-label]            = \"layer.menuLabel\"\n\t\t[layer-menu-label-secondary]  = \"layer.menuLabelSecondary\"\n\t\t[layer-ref]                   = \"layer\"\n\t\t(onToggleSelected)            = \"onWSLayerSelected($event)\"\n\t\t(onToggleVisibility)          = \"onWSLayerVisibilityToggled($event)\"\n\t\t(onToggleInWS)                = \"onWSLayerInWSToggled($event)\">\n\t</o-map-workspace-layer>\n</div>\n", styles: [".o-map-workspace{overflow:auto}.o-map-workspace .workspace-controls{position:fixed;box-sizing:border-box;margin-top:-8px;left:0;z-index:1;width:100%;height:64px;padding:8px;box-shadow:0 6px 18px -9px,0 -6px 18px -9px}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$2.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i2$2.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "component", type: OMapWorkspaceLayerComponent, selector: "o-map-workspace-layer", inputs: ["layer-selected", "layer-visible", "layer-in-ws", "layer-menu-label", "layer-menu-label-secondary", "layer-ref", "layer-index"], outputs: ["onToggleSelected", "onToggleVisibility", "onToggleInWS"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapWorkspaceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-workspace', inputs: [], outputs: [
                        'onToggleWSLayerSelected',
                        'onToggleWSLayerVisibility',
                        'onToggleWSLayerInWS'
                    ], encapsulation: ViewEncapsulation.None, host: {
                        '[class.o-map-workspace]': 'true'
                    }, providers: [
                        { provide: OMapWorkspaceBase, useExisting: forwardRef(() => OMapWorkspaceComponent) }
                    ], template: "<div cdkDropList (cdkDropListDropped)=\"onListitemDragDrop($event)\">\n\t<o-map-workspace-layer *ngFor=\"let layer of oSearchableCollection; let x = index\" cdkDrag\n\t\t[layer-index]\t\t\t\t\t\t\t\t\t= \"x\"\n\t\t[layer-selected]              = \"layer.selected\"\n\t\t[layer-visible]               = \"layer.visible\"\n\t\t[layer-in-ws]                 = \"layer.inWS\"\n\t\t[layer-menu-label]            = \"layer.menuLabel\"\n\t\t[layer-menu-label-secondary]  = \"layer.menuLabelSecondary\"\n\t\t[layer-ref]                   = \"layer\"\n\t\t(onToggleSelected)            = \"onWSLayerSelected($event)\"\n\t\t(onToggleVisibility)          = \"onWSLayerVisibilityToggled($event)\"\n\t\t(onToggleInWS)                = \"onWSLayerInWSToggled($event)\">\n\t</o-map-workspace-layer>\n</div>\n", styles: [".o-map-workspace{overflow:auto}.o-map-workspace .workspace-controls{position:fixed;box-sizing:border-box;margin-top:-8px;left:0;z-index:1;width:100%;height:64px;padding:8px;box-shadow:0 6px 18px -9px,0 -6px 18px -9px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: OMapBase$1, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapBase$1)]
                    }] }];
    } });

class ONavigatorDefault {
    constructor(geocoder, translateMapService, oMap) {
        this.geocoder = geocoder;
        this.translateMapService = translateMapService;
        this.oMap = oMap;
        this._searchResults = new Array();
        this.cachedAddress = '';
        this.locationSearcher = new SearcherDefault('Lugares', () => this.locationResults);
        this.locationResults = new Array();
        oMap.mapSearchers.splice(0, 0, this.locationSearcher);
    }
    get address() {
        return this.cachedAddress;
    }
    set address(address) {
        this.cachedAddress = address;
    }
    goto() {
        if (!this.address) {
            return;
        }
        this.geocoder.geocode(this.address).subscribe((locations) => {
            locations.forEach(l => {
                const callback = () => {
                    this.oMap.getMapService().map.panTo([l.latitude, l.longitude]);
                    this.address = l.address;
                    return true;
                };
                this.locationResults.push({
                    searchTerm: this.address,
                    resultAddress: l.address,
                    oSearchKeys: ['searchTerm', 'resultAddress'],
                    oSearchResult: {
                        label: l.address,
                        icon: 'location_on',
                        buttons: [{
                                icon: ['directions'],
                                status: () => true,
                                callback: callback
                            }]
                    }
                });
            });
            this.address = this.address;
        }, error => console.error(error));
    }
    search() {
        this.closeSearch();
        if (Util.isBlank(this.address)) {
            return false;
        }
        this.searchResults = [{
                oSearchKeys: [],
                oSearchResult: {
                    label: this.address,
                    icon: 'location_on',
                    buttons: [{
                            icon: ['search'],
                            status: () => true,
                            callback: () => (this.goto(), true)
                        }]
                }
            }];
        this.searchObserver = this.oMap.search(this.address).subscribe(a => {
            this.searchResults = this.searchResults.concat(a);
        });
        return true;
    }
    closeSearch() {
        this.searchResults.splice(0, this.searchResults.length);
        if (!!this.searchObserver) {
            this.searchObserver.unsubscribe();
            this.searchObserver.closed = true;
        }
    }
    get searchResults() {
        return this._searchResults;
    }
    set searchResults(val) {
        this._searchResults = val;
    }
}

class ONavigatorItemComponent {
    constructor() {
        this.actionButtons = new Array();
    }
    get actions() {
        if (this.actionButtons.length !== this.searchResult.buttons.length) {
            this.actionButtons = this.searchResult.buttons;
        }
        return this.actionButtons;
    }
    trueStatusIcon(button) {
        return (!button.icon || !button.icon.length) ? '' : button.icon.slice(0, 1)[0];
    }
    falseStatusIcon(button) {
        return (!button.icon || !button.icon.length) ? '' : button.icon.slice(-1, button.icon.length)[0];
    }
    getIcon(button) {
        return button.status() ? this.trueStatusIcon(button) : this.falseStatusIcon(button);
    }
    get searchResult() {
        return this._searchResult;
    }
    set searchResult(val) {
        this._searchResult = val;
    }
}
ONavigatorItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: ONavigatorItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ONavigatorItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: ONavigatorItemComponent, selector: "o-navigator-item", inputs: { searchResult: ["search-result", "searchResult"] }, ngImport: i0, template: "<div class=\"search-result\" fxLayout=\"row\">\n\t<i class=\"material-icons\" *ngIf=\"searchResult.icon\">{{ searchResult.icon }}</i>\n\t<div fxFlex fxLayout=\"column\" fxLayoutAlign=\"center start\">\n\t\t<span *ngIf=\"searchResult.label\">{{ searchResult.label }}</span>\n\t\t<span class=\"sub-label\" *ngIf=\"searchResult.sublabel\">{{ searchResult.sublabel }}</span>\n\t</div>\n\t<o-toggle-icon-button *ngFor=\"let button of actions\"\n\t\ticon-dark=\"true\" clickable=\"false\"\n\t\t[icon-name]=\"getIcon(button)\"\n\t\t[button-active]=\"button.status()\"\n\t\t(click)=\"button.callback()\">\n\t</o-toggle-icon-button>\n</div>\n", styles: [":host{min-width:100%}.search-result{font-size:14px}button{width:54px;height:48px;min-width:initial;padding:0}.material-icons{width:48px;line-height:48px;text-align:center}.sub-label{font-size:.8em}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.DefaultFlexDirective, selector: "  [fxFlex], [fxFlex.xs], [fxFlex.sm], [fxFlex.md],  [fxFlex.lg], [fxFlex.xl], [fxFlex.lt-sm], [fxFlex.lt-md],  [fxFlex.lt-lg], [fxFlex.lt-xl], [fxFlex.gt-xs], [fxFlex.gt-sm],  [fxFlex.gt-md], [fxFlex.gt-lg]", inputs: ["fxFlex", "fxFlex.xs", "fxFlex.sm", "fxFlex.md", "fxFlex.lg", "fxFlex.xl", "fxFlex.lt-sm", "fxFlex.lt-md", "fxFlex.lt-lg", "fxFlex.lt-xl", "fxFlex.gt-xs", "fxFlex.gt-sm", "fxFlex.gt-md", "fxFlex.gt-lg"] }, { kind: "component", type: OToggleIconButtonComponent, selector: "o-toggle-icon-button", inputs: ["button-active", "icon-dark", "icon-name", "bg-color", "clickable", "no-ink"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: ONavigatorItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-navigator-item', inputs: [
                        'searchResult : search-result'
                    ], template: "<div class=\"search-result\" fxLayout=\"row\">\n\t<i class=\"material-icons\" *ngIf=\"searchResult.icon\">{{ searchResult.icon }}</i>\n\t<div fxFlex fxLayout=\"column\" fxLayoutAlign=\"center start\">\n\t\t<span *ngIf=\"searchResult.label\">{{ searchResult.label }}</span>\n\t\t<span class=\"sub-label\" *ngIf=\"searchResult.sublabel\">{{ searchResult.sublabel }}</span>\n\t</div>\n\t<o-toggle-icon-button *ngFor=\"let button of actions\"\n\t\ticon-dark=\"true\" clickable=\"false\"\n\t\t[icon-name]=\"getIcon(button)\"\n\t\t[button-active]=\"button.status()\"\n\t\t(click)=\"button.callback()\">\n\t</o-toggle-icon-button>\n</div>\n", styles: [":host{min-width:100%}.search-result{font-size:14px}button{width:54px;height:48px;min-width:initial;padding:0}.material-icons{width:48px;line-height:48px;text-align:center}.sub-label{font-size:.8em}\n"] }]
        }] });

const DEFAULT_INPUTS$3 = [
    'showSidenavButton: show-sidenav-button',
    'showSearchInput: show-search-input'
];
class ONavigatorComponent extends ONavigatorDefault {
    constructor(geocoder, translateMapService, oMap) {
        super(geocoder, translateMapService, oMap);
        this.showSidenavButton = true;
        this.showSearchInput = true;
        this._rendered = false;
        this.oMapConfigurationSubscription = this.oMap.onMapConfigured().subscribe(() => {
            if (this.isSearchInputVisible) {
                this.oMap.getMapService().disableMouseEvent('place-input');
            }
        });
    }
    ngOnDestroy() {
        if (this.oMapConfigurationSubscription) {
            this.oMapConfigurationSubscription.unsubscribe();
        }
    }
    getText(text) {
        if (this.translateMapService) {
            return this.translateMapService.get(text);
        }
        return text;
    }
    get address() {
        return this.cachedAddress;
    }
    set address(address) {
        this.cachedAddress = address;
        this.rendered = this.search();
    }
    toggleSidenav(e) {
        this.oMap.toggleSidenav(e);
    }
    onBlur() {
        this.rendered = false;
        setTimeout(() => {
            if (this.rendered === false) {
                this.closeSearch();
            }
        }, 350);
    }
    onFocus() {
        if (this.rendered === false) {
            this.rendered = this.search();
        }
    }
    get rendered() {
        return this._rendered;
    }
    set rendered(val) {
        this._rendered = val;
    }
    get isSearchInputVisible() {
        return this.showSearchInput;
    }
    set isSearchInputVisible(val) {
        this.showSearchInput = val;
    }
    get isSidenavButtonVisible() {
        return this.showSidenavButton;
    }
    set isSidenavButtonVisible(val) {
        this.showSidenavButton = val;
    }
}
ONavigatorComponent.DEFAULT_INPUTS = DEFAULT_INPUTS$3;
ONavigatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: ONavigatorComponent, deps: [{ token: GeocodingService }, { token: TranslateMapService }, { token: forwardRef(() => OMapBase$1) }], target: i0.ɵɵFactoryTarget.Component });
ONavigatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: ONavigatorComponent, selector: "o-navigator", inputs: { showSidenavButton: ["show-sidenav-button", "showSidenavButton"], showSearchInput: ["show-search-input", "showSearchInput"] }, usesInheritance: true, ngImport: i0, template: "<div fxLayout=\"row\" layout-padding layout-wrap ng-cloak>\n  <div class=\"search-panel on-map mat-elevation-z2\" fxLayout=\"row\" fxLayoutAlign=\"start center\">\n    <button *ngIf=\"isSidenavButtonVisible\" mat-button class=\"mat-button\" (click)=\"toggleSidenav($event)\">\n      <i class=\"material-icons\">menu</i>\n    </button>\n    <input *ngIf=\"isSearchInputVisible\" id=\"place-input\" class=\"on-map\" type=\"text\" fxFlex\n      [placeholder]=\"getText('SEARCH_PLACEHOLDER')\" [(ngModel)]=\"address\" (blur)=\"onBlur()\" (click)=\"onFocus()\">\n  </div>\n</div>\n<div *ngIf=\"searchResults.length > 0\" fxLayout=\"row\" layout-padding fxLayoutWrap ng-cloak>\n  <div class=\"search-results on-map mat-elevation-z2\" fxFlex fxLayout=\"column\" fxLayoutAlign=\"start center\"\n    [class.rendered]=\"rendered\">\n    <o-navigator-item *ngFor=\"let item of searchResults\" [search-result]=\"item.oSearchResult\">\n    </o-navigator-item>\n  </div>\n</div>", styles: [".search-panel{height:48px;background:white;border-radius:4px;overflow:hidden}input{border:none;font-size:16px;color:#8e8e8e;padding:.1em .25em;outline:none}button.mdc-button.mat-mdc-button{width:54px;min-width:54px;height:48px}button.mdc-button.mat-mdc-button i{line-height:48px}.search-results{padding:0;background:white;border-radius:4px;max-height:0;overflow:hidden;transition:.35s;transition-timing-function:ease-in-out}.search-results.rendered{max-height:70vh;overflow:auto}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i2$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.DefaultFlexDirective, selector: "  [fxFlex], [fxFlex.xs], [fxFlex.sm], [fxFlex.md],  [fxFlex.lg], [fxFlex.xl], [fxFlex.lt-sm], [fxFlex.lt-md],  [fxFlex.lt-lg], [fxFlex.lt-xl], [fxFlex.gt-xs], [fxFlex.gt-sm],  [fxFlex.gt-md], [fxFlex.gt-lg]", inputs: ["fxFlex", "fxFlex.xs", "fxFlex.sm", "fxFlex.md", "fxFlex.lg", "fxFlex.xl", "fxFlex.lt-sm", "fxFlex.lt-md", "fxFlex.lt-lg", "fxFlex.lt-xl", "fxFlex.gt-xs", "fxFlex.gt-sm", "fxFlex.gt-md", "fxFlex.gt-lg"] }, { kind: "component", type: ONavigatorItemComponent, selector: "o-navigator-item", inputs: ["search-result"] }] });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], ONavigatorComponent.prototype, "showSidenavButton", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], ONavigatorComponent.prototype, "showSearchInput", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: ONavigatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-navigator', inputs: DEFAULT_INPUTS$3, template: "<div fxLayout=\"row\" layout-padding layout-wrap ng-cloak>\n  <div class=\"search-panel on-map mat-elevation-z2\" fxLayout=\"row\" fxLayoutAlign=\"start center\">\n    <button *ngIf=\"isSidenavButtonVisible\" mat-button class=\"mat-button\" (click)=\"toggleSidenav($event)\">\n      <i class=\"material-icons\">menu</i>\n    </button>\n    <input *ngIf=\"isSearchInputVisible\" id=\"place-input\" class=\"on-map\" type=\"text\" fxFlex\n      [placeholder]=\"getText('SEARCH_PLACEHOLDER')\" [(ngModel)]=\"address\" (blur)=\"onBlur()\" (click)=\"onFocus()\">\n  </div>\n</div>\n<div *ngIf=\"searchResults.length > 0\" fxLayout=\"row\" layout-padding fxLayoutWrap ng-cloak>\n  <div class=\"search-results on-map mat-elevation-z2\" fxFlex fxLayout=\"column\" fxLayoutAlign=\"start center\"\n    [class.rendered]=\"rendered\">\n    <o-navigator-item *ngFor=\"let item of searchResults\" [search-result]=\"item.oSearchResult\">\n    </o-navigator-item>\n  </div>\n</div>", styles: [".search-panel{height:48px;background:white;border-radius:4px;overflow:hidden}input{border:none;font-size:16px;color:#8e8e8e;padding:.1em .25em;outline:none}button.mdc-button.mat-mdc-button{width:54px;min-width:54px;height:48px}button.mdc-button.mat-mdc-button i{line-height:48px}.search-results{padding:0;background:white;border-radius:4px;max-height:0;overflow:hidden;transition:.35s;transition-timing-function:ease-in-out}.search-results.rendered{max-height:70vh;overflow:auto}\n"] }]
        }], ctorParameters: function () {
        return [{ type: GeocodingService, decorators: [{
                        type: Inject,
                        args: [GeocodingService]
                    }] }, { type: TranslateMapService, decorators: [{
                        type: Inject,
                        args: [TranslateMapService]
                    }] }, { type: OMapBase$1, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapBase$1)]
                    }] }];
    }, propDecorators: { showSidenavButton: [], showSearchInput: [] } });

const DEFAULT_INPUTS$2 = [
    'sAttr: attr',
    'sCenter: center',
    'sZoom: zoom',
    'sMinZoom: min-zoom',
    'sMaxZoom: max-zoom',
    'sZoomControl: zoom-control',
    'sSearchControl: search-control',
    'sSearchControlButtonVisible: search-control-button-visible',
    'sDrawControl: draw-control',
    'sLayerPanelVisible: layer-panel-visible',
    'sBaseLayerIds: base-layer-ids',
    'sidenavMode: sidenav-mode',
    'showBaseLayersMenu: show-base-layers-menu',
    'showLayersMenu: show-layers-menu',
    'showWorkspaceMenu: show-workspace-menu',
    'contextMenu : layer-contextmenu',
    'queryFeaturesInBounds: query-features-in-bounds'
];
const DEFAULT_OUTPUTS$2 = [
    'onToggleWSLayerSelected',
    'onToggleWSLayerVisibility',
    'onToggleWSLayerInWS',
    'onClick',
    'onDrag',
    'onMove',
    'onMoveEnd',
    'onZoomLevelsChange',
    'onZoomStart',
    'onZoomEnd',
    'onZoom',
    'onDrawEvent',
    'onDrawCreated',
    'onDrawEdited',
    'onDrawDeleted',
    'onDrawDrawStart',
    'onDrawDrawstop',
    'onDrawvertex',
    'onDrawEditStart',
    'onDrawEditMove',
    'onDrawEditResize',
    'onDrawEditvertex',
    'onDrawEditStop',
    'onDrawDeleteStart',
    'onDrawDeleteStop'
];
class OMapComponent extends OMapWSearch {
    set sCenter(center) {
        this.setCenter(center);
    }
    get sidenavMode() { return this._sidenavMode; }
    set sidenavMode(value) {
        this._sidenavMode = value;
    }
    constructor(elRef, injector) {
        super();
        this.elRef = elRef;
        this.injector = injector;
        this.onToggleWSLayerSelected = new EventEmitter();
        this.onToggleWSLayerVisibility = new EventEmitter();
        this.onToggleWSLayerInWS = new EventEmitter();
        this._sidenavMode = 'over';
        this.showBaseLayersMenu = true;
        this.showLayersMenu = true;
        this.showWorkspaceMenu = true;
        this.queryFeaturesInBounds = true;
        this._waitForBuild = false;
        this._searchControl = true;
        this._searchControlButtonVisible = true;
        this.mapService = this.injector.get(MapService);
        this.translateMapService = this.injector.get(TranslateMapService);
        try {
            this.tabGroupContainer = this.injector.get(MatTabGroup);
            this.tabContainer = this.injector.get(MatTab);
            if (this.tabGroupContainer && this.tabContainer) {
                this.waitForBuild = true;
            }
        }
        catch (error) {
        }
    }
    getInjector() {
        return this.injector;
    }
    ngOnInit() {
        if (!this.waitForBuild) {
            this.initialize();
        }
        else {
            this.waitForBuild = true;
        }
    }
    ngAfterViewInit() {
        if (this.waitForBuild && !this.tabContainer.content.isAttached) {
            this.registerTabGroupListener();
        }
        else if (this.waitForBuild) {
            this.initialize();
        }
        if (this.mapLayerContainerQueryList && this.mapLayerContainerQueryList.length > 0) {
            this.mapLayerContainerComponent = this.mapLayerContainerQueryList.first;
        }
    }
    initialize() {
        this.mapId = this.sAttr ? this.sAttr : 'map_' + new Date().getTime();
        this.zoom = {
            current: parseInt(this.sZoom, 10),
            min: parseInt(this.sMinZoom, 10),
            max: parseInt(this.sMaxZoom, 10),
            control: Util.parseBoolean(this.sZoomControl, true)
        };
        this.searchControl = Util.parseBoolean(this.sSearchControl, true);
        this.isSearchControlButtonVisible = Util.parseBoolean(this.sSearchControlButtonVisible, true);
        this.drawDefaultControl = Util.parseBoolean(this.sDrawControl, false);
        this.isSidenavVisible = Util.parseBoolean(this.sLayerPanelVisible, false);
        this.baseLayerIds = Util.parseArray(this.sBaseLayerIds);
        this.mapService.configureBaseLayers(this.baseLayerIds);
        const self = this;
        setTimeout(() => {
            if (!self.mapService.map) {
                self.configureMap();
            }
            if (self.drawDefaultControl && !self.drawControlComponent) {
                self.configureDefaultDrawControl(self.mapService.getMap());
            }
            self.onMapAfterViewInit().emit(self);
            self.onMapReady().next(self);
        }, 0);
    }
    registerCRSComponent(crsComp) {
        this.crsComponent = crsComp;
    }
    registerTabGroupListener() {
        const self = this;
        this.tabGroupSubscription = this.tabGroupContainer.selectedTabChange.subscribe((evt) => {
            const interval = setInterval(function () { timerCallback(evt.tab); }, 250);
            function timerCallback(tab) {
                if (tab && tab.content.isAttached) {
                    clearInterval(interval);
                    if (tab === self.tabContainer) {
                        self.tabGroupSubscription.unsubscribe();
                        self.initialize();
                        self.waitForBuild = false;
                    }
                }
            }
        });
    }
    ngOnDestroy() {
        if (this.tabGroupSubscription) {
            this.tabGroupSubscription.unsubscribe();
        }
    }
    get waitForBuild() {
        return this._waitForBuild;
    }
    set waitForBuild(val) {
        this._waitForBuild = val;
    }
    onWSLayerSelected(event) {
        this.onToggleWSLayerSelected.emit(event);
    }
    onWSLayerVisibilityToggled(event) {
        this.onToggleWSLayerVisibility.emit(event);
    }
    onWSLayerInWSToggled(event) {
        this.onToggleWSLayerInWS.emit(event);
    }
    getText(text) {
        if (this.translateMapService) {
            return this.translateMapService.get(text);
        }
        return text;
    }
    configureMap() {
        L.Icon.Default.imagePath = './assets/';
        const mapOptions = {
            zoomControl: false,
            center: new L.LatLng(this.getCenter().latitude, this.getCenter().longitude),
            zoom: this.zoom.current || 12,
            minZoom: this.zoom.min || 4,
            maxZoom: this.zoom.max || 19,
            layers: this.mapService.baseLayers.getLayersArray()
        };
        if (this.contextMenu) {
            mapOptions['contextmenu'] = true;
            mapOptions['contextmenuWidth'] = this.contextMenu.contextmenuWidth;
            mapOptions['contextmenuItems'] = this.contextMenu.contextmenuItems;
        }
        if (this.crsComponent) {
            const crsConf = this.crsComponent.getCRS();
            if (crsConf) {
                mapOptions['crs'] = crsConf;
            }
        }
        const map = this.mapService.getMap(this.mapId, mapOptions);
        L.control.scale().addTo(map);
        if (this.zoom.control) {
            L.control.zoom({ position: 'bottomright' }).addTo(map);
        }
        this.onMapConfigured().emit(true);
    }
    get searchControl() {
        return this._searchControl;
    }
    set searchControl(val) {
        this._searchControl = val;
    }
    get isSearchControlButtonVisible() {
        return this._searchControlButtonVisible;
    }
    set isSearchControlButtonVisible(val) {
        this._searchControlButtonVisible = val;
    }
    get isNavigatorVisible() {
        return this._searchControl || this._searchControlButtonVisible;
    }
    get navigatorState() {
        let value = 'none';
        if (this.sidenavMode === 'over' && this.sideNavCmp) {
            value = this.sideNavCmp.opened ? 'open' : 'closed';
        }
        return {
            value: value,
            params: {
                navigatorExpandedPosition: this.navigatorExpandedPosition
            }
        };
    }
    get navigatorExpandedPosition() {
        let result = 0;
        if (this.sideNavCmp && this.sideNavCmp.opened) {
            result = this.sideNavCmp._getWidth();
        }
        return result + 'px';
    }
    set contextMenu(val) {
        if (!val) {
            return;
        }
        this._contextmenu = val;
        if (val.defaultContextmenuItems) {
            this._contextmenu.contextmenuItems =
                this._contextmenu.contextmenuItems.concat(this.getMapService().defaultContextMenu.contextmenuItems);
        }
        if (!this._contextmenu.contextmenuItems) {
            return;
        }
        this._contextmenu.contextmenuItems = this.getMapService().parseContextmenuItems(this._contextmenu.contextmenuItems);
    }
    get contextMenu() {
        return this._contextmenu;
    }
}
OMapComponent.DEFAULT_INPUTS = DEFAULT_INPUTS$2;
OMapComponent.DEFAULT_OUTPUTS = DEFAULT_OUTPUTS$2;
OMapComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapComponent, deps: [{ token: i0.ElementRef }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
OMapComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapComponent, selector: "o-map", inputs: { sAttr: ["attr", "sAttr"], sCenter: ["center", "sCenter"], sZoom: ["zoom", "sZoom"], sMinZoom: ["min-zoom", "sMinZoom"], sMaxZoom: ["max-zoom", "sMaxZoom"], sZoomControl: ["zoom-control", "sZoomControl"], sSearchControl: ["search-control", "sSearchControl"], sSearchControlButtonVisible: ["search-control-button-visible", "sSearchControlButtonVisible"], sDrawControl: ["draw-control", "sDrawControl"], sLayerPanelVisible: ["layer-panel-visible", "sLayerPanelVisible"], sBaseLayerIds: ["base-layer-ids", "sBaseLayerIds"], sidenavMode: ["sidenav-mode", "sidenavMode"], showBaseLayersMenu: ["show-base-layers-menu", "showBaseLayersMenu"], showLayersMenu: ["show-layers-menu", "showLayersMenu"], showWorkspaceMenu: ["show-workspace-menu", "showWorkspaceMenu"], contextMenu: ["layer-contextmenu", "contextMenu"], queryFeaturesInBounds: ["query-features-in-bounds", "queryFeaturesInBounds"] }, outputs: { onToggleWSLayerSelected: "onToggleWSLayerSelected", onToggleWSLayerVisibility: "onToggleWSLayerVisibility", onToggleWSLayerInWS: "onToggleWSLayerInWS", onClick: "onClick", onDrag: "onDrag", onMove: "onMove", onMoveEnd: "onMoveEnd", onZoomLevelsChange: "onZoomLevelsChange", onZoomStart: "onZoomStart", onZoomEnd: "onZoomEnd", onZoom: "onZoom", onDrawEvent: "onDrawEvent", onDrawCreated: "onDrawCreated", onDrawEdited: "onDrawEdited", onDrawDeleted: "onDrawDeleted", onDrawDrawStart: "onDrawDrawStart", onDrawDrawstop: "onDrawDrawstop", onDrawvertex: "onDrawvertex", onDrawEditStart: "onDrawEditStart", onDrawEditMove: "onDrawEditMove", onDrawEditResize: "onDrawEditResize", onDrawEditvertex: "onDrawEditvertex", onDrawEditStop: "onDrawEditStop", onDrawDeleteStart: "onDrawDeleteStart", onDrawDeleteStop: "onDrawDeleteStop" }, host: { properties: { "class.o-map": "true" } }, providers: [MapService, GeocodingService, { provide: OMapBase$1, useExisting: forwardRef(() => OMapComponent) }], queries: [{ propertyName: "mapLayerContainerQueryList", predicate: OMapLayerContainerComponent }], viewQueries: [{ propertyName: "markerComponent", first: true, predicate: OMarkerComponent, descendants: true }, { propertyName: "sideNavCmp", first: true, predicate: ["sidenav"], descendants: true }, { propertyName: "mapLayerGroup", first: true, predicate: ["mainLayerGroup"], descendants: true }, { propertyName: "mapWorkspace", first: true, predicate: ["oMapWorkspace"], descendants: true }, { propertyName: "navigatorContainer", first: true, predicate: ["navigatorContainer"], descendants: true }, { propertyName: "mapBaseLayerGroup", predicate: ["mainBaseLayerGroup"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<!--\n\tTODO replace this div with o-frame if it goes into the framework\n\tFrame to create the sidebar\n-->\n<mat-sidenav-container fxFlexFill hasBackdrop=\"false\">\n  <mat-sidenav #sidenav id=\"layers\" name=\"layers\" [mode]=\"sidenavMode\" [opened]=\"isSidenavVisible\">\n    <div fxLayout=\"column\" fxLayoutAlign=\"start stretch\">\n\n      <ng-container *ngIf=\"showBaseLayersMenu\">\n        <!-- Header for Layer Base -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <span class=\"mat-expansion-indicator o-close-sidenav\" (click)=\"toggleSidenav($event)\">\n            </span>\n            <mat-panel-title>\n              {{ getText('MAP_BASE_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-grid if it goes into the framework. Block with a grid of Base Layers -->\n          <div fxLayout=\"row\" fxLayoutAlign=\"space-evenly center\" class=\"group-ref\">\n            <o-map-base-layer #mainBaseLayerGroup *ngFor=\"let baseLayer of baseLayers\" [layer-id]=\"baseLayer.id\"\n              [title]=\"baseLayer.name\" [src]=\"baseLayer.urlTemplate\" [active]=\"baseLayer.active\" fxLayout fxLayoutAlign=\"center center\">\n            </o-map-base-layer>\n          </div>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"showLayersMenu\">\n        <!-- Header for Layers -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <mat-panel-title>\n              {{ getText('MAP_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-tree-list if it goes into the framework. Block with a hierarquical list of Layers and LayerGroups -->\n          <div class=\"group-ref\">\n            <ng-content></ng-content>\n            <o-map-layer-group class=\"o-map-layer-group\" #mainLayerGroup></o-map-layer-group>\n          </div>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"showWorkspaceMenu\">\n        <!-- Header for Workspace -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <mat-panel-title>\n              {{ getText('MAP_WORKSPACE_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-list if it goes into the framework. Block with a simple list of WorkspaceLayers -->\n          <o-map-workspace #oMapWorkspace (onToggleWSLayerSelected)=\"onWSLayerSelected($event)\"\n            (onToggleWSLayerVisibility)=\"onWSLayerVisibilityToggled($event)\"\n            (onToggleWSLayerInWS)=\"onWSLayerInWSToggled($event)\">\n          </o-map-workspace>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"mapLayerContainerComponent\">\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n\n            <ng-template #headerContent [ngTemplateOutlet]=\"mapLayerContainerComponent.headerTemplateref\">\n            </ng-template>\n\n            <mat-panel-title>\n              {{ mapLayerContainerComponent.label }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n          <ng-content select=\"o-map-layer-container\"></ng-content>\n        </mat-expansion-panel>\n      </ng-container>\n    </div>\n  </mat-sidenav>\n  <!--\n\t\tTODO o-frame sidebar container\n\t\tMap Section\n\t-->\n  <div fxLayout=\"column\" fxLayoutAlign=\"top start\" fxFlexFill>\n    <!--\n      Map container for Leaflet\n    -->\n    <div [id]=\"mapId\" class=\"leaflet-map-container\"></div>\n    <!--\n      Omnibar o-navigator\n    -->\n    <div *ngIf=\"isNavigatorVisible\" #navigatorContainer [@navigatorState]=\"navigatorState\" fxLayout=\"row\"\n      fxLayoutAlign=\"start center\">\n      <o-navigator [show-search-input]=\"searchControl\" [show-sidenav-button]=\"isSearchControlButtonVisible\">\n      </o-navigator>\n    </div>\n  </div>\n</mat-sidenav-container>", styles: ["mat-sidenav#layers{width:350px}mat-sidenav#layers .mat-toolbar.mat-toolbar-single-row{padding-left:16px;line-height:40px}mat-sidenav#layers mat-toolbar,mat-sidenav#layers mat-toolbar-row{min-height:40px;height:40px;border-bottom:2px solid #ccc;padding:0}mat-sidenav#layers mat-toolbar button,mat-sidenav#layers mat-toolbar-row button{min-width:54px;height:40px}.mat-pushed-closed{transition:all .3s cubic-bezier(.55,0,.55,.2);padding-left:0!important}.mat-sidenav-left.mat-open,mat-sidenav.mat-sidenav-opened{transform:translateZ(0);visibility:initial;transition:transform .2s ease-in;-webkit-user-select:none;user-select:none}.o-map .leaflet-map-container{position:absolute;top:0;bottom:0;width:100%}.o-map .leaflet-map-container .sidenav-toggle-btn{position:absolute;left:8px;top:8px}.o-map .group-ref{max-height:30%;overflow:auto}.o-map .mat-expansion-panel .mat-expansion-panel-header{padding:0 16px;flex-direction:row-reverse}.o-map .mat-expansion-panel .mat-expansion-panel-header .mat-content{padding-left:12px}.o-map .mat-expansion-panel .mat-expansion-panel-header-title{font-size:16px}.o-map .mat-expansion-panel .mat-expansion-panel-content{font:inherit}.o-map .mat-expansion-panel .mat-expansion-indicator{padding-bottom:6px}.o-map .mat-expansion-panel .mat-expansion-indicator.o-close-sidenav{width:24px;text-align:center;padding:0}.o-map .mat-expansion-panel .mat-expansion-indicator.o-close-sidenav:after{transform:rotate(135deg)}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i2$4.MatExpansionPanel, selector: "mat-expansion-panel", inputs: ["disabled", "expanded", "hideToggle", "togglePosition"], outputs: ["opened", "closed", "expandedChange", "afterExpand", "afterCollapse"], exportAs: ["matExpansionPanel"] }, { kind: "component", type: i2$4.MatExpansionPanelHeader, selector: "mat-expansion-panel-header", inputs: ["tabIndex", "expandedHeight", "collapsedHeight"] }, { kind: "directive", type: i2$4.MatExpansionPanelTitle, selector: "mat-panel-title" }, { kind: "component", type: i3$2.MatSidenav, selector: "mat-sidenav", inputs: ["fixedInViewport", "fixedTopGap", "fixedBottomGap"], exportAs: ["matSidenav"] }, { kind: "component", type: i3$2.MatSidenavContainer, selector: "mat-sidenav-container", exportAs: ["matSidenavContainer"] }, { kind: "directive", type: i3$1.DefaultLayoutDirective, selector: "  [fxLayout], [fxLayout.xs], [fxLayout.sm], [fxLayout.md],  [fxLayout.lg], [fxLayout.xl], [fxLayout.lt-sm], [fxLayout.lt-md],  [fxLayout.lt-lg], [fxLayout.lt-xl], [fxLayout.gt-xs], [fxLayout.gt-sm],  [fxLayout.gt-md], [fxLayout.gt-lg]", inputs: ["fxLayout", "fxLayout.xs", "fxLayout.sm", "fxLayout.md", "fxLayout.lg", "fxLayout.xl", "fxLayout.lt-sm", "fxLayout.lt-md", "fxLayout.lt-lg", "fxLayout.lt-xl", "fxLayout.gt-xs", "fxLayout.gt-sm", "fxLayout.gt-md", "fxLayout.gt-lg"] }, { kind: "directive", type: i3$1.DefaultLayoutAlignDirective, selector: "  [fxLayoutAlign], [fxLayoutAlign.xs], [fxLayoutAlign.sm], [fxLayoutAlign.md],  [fxLayoutAlign.lg], [fxLayoutAlign.xl], [fxLayoutAlign.lt-sm], [fxLayoutAlign.lt-md],  [fxLayoutAlign.lt-lg], [fxLayoutAlign.lt-xl], [fxLayoutAlign.gt-xs], [fxLayoutAlign.gt-sm],  [fxLayoutAlign.gt-md], [fxLayoutAlign.gt-lg]", inputs: ["fxLayoutAlign", "fxLayoutAlign.xs", "fxLayoutAlign.sm", "fxLayoutAlign.md", "fxLayoutAlign.lg", "fxLayoutAlign.xl", "fxLayoutAlign.lt-sm", "fxLayoutAlign.lt-md", "fxLayoutAlign.lt-lg", "fxLayoutAlign.lt-xl", "fxLayoutAlign.gt-xs", "fxLayoutAlign.gt-sm", "fxLayoutAlign.gt-md", "fxLayoutAlign.gt-lg"] }, { kind: "directive", type: i3$1.FlexFillDirective, selector: "[fxFill], [fxFlexFill]" }, { kind: "component", type: OMapBaseLayerComponent, selector: "o-map-base-layer", inputs: ["layer-id", "title", "src", "active"] }, { kind: "component", type: OMapLayerGroupComponent, selector: "o-map-layer-group", inputs: ["group-id", "group-id-parent", "group-name", "group-description", "group-collapsed", "group-ref"] }, { kind: "component", type: OMapWorkspaceComponent, selector: "o-map-workspace", outputs: ["onToggleWSLayerSelected", "onToggleWSLayerVisibility", "onToggleWSLayerInWS"] }, { kind: "component", type: ONavigatorComponent, selector: "o-navigator", inputs: ["show-sidenav-button", "show-search-input"] }], animations: [
        trigger('navigatorState', [
            state('closed', style({
                position: 'absolute',
                left: '0px'
            })),
            state('open', style({
                position: 'absolute',
                left: '{{navigatorExpandedPosition}}'
            }), { params: { navigatorExpandedPosition: '0px' } }),
            transition('collapsed <=> expanded', animate('400ms cubic-bezier(0.25, 0.8, 0.25, 1)'))
        ])
    ], encapsulation: i0.ViewEncapsulation.None });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapComponent.prototype, "showBaseLayersMenu", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapComponent.prototype, "showLayersMenu", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapComponent.prototype, "showWorkspaceMenu", void 0);
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapComponent.prototype, "queryFeaturesInBounds", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map', providers: [MapService, GeocodingService, { provide: OMapBase$1, useExisting: forwardRef(() => OMapComponent) }], inputs: OMapComponent.DEFAULT_INPUTS, outputs: OMapComponent.DEFAULT_OUTPUTS, encapsulation: ViewEncapsulation.None, animations: [
                        trigger('navigatorState', [
                            state('closed', style({
                                position: 'absolute',
                                left: '0px'
                            })),
                            state('open', style({
                                position: 'absolute',
                                left: '{{navigatorExpandedPosition}}'
                            }), { params: { navigatorExpandedPosition: '0px' } }),
                            transition('collapsed <=> expanded', animate('400ms cubic-bezier(0.25, 0.8, 0.25, 1)'))
                        ])
                    ], host: {
                        '[class.o-map]': 'true'
                    }, template: "<!--\n\tTODO replace this div with o-frame if it goes into the framework\n\tFrame to create the sidebar\n-->\n<mat-sidenav-container fxFlexFill hasBackdrop=\"false\">\n  <mat-sidenav #sidenav id=\"layers\" name=\"layers\" [mode]=\"sidenavMode\" [opened]=\"isSidenavVisible\">\n    <div fxLayout=\"column\" fxLayoutAlign=\"start stretch\">\n\n      <ng-container *ngIf=\"showBaseLayersMenu\">\n        <!-- Header for Layer Base -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <span class=\"mat-expansion-indicator o-close-sidenav\" (click)=\"toggleSidenav($event)\">\n            </span>\n            <mat-panel-title>\n              {{ getText('MAP_BASE_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-grid if it goes into the framework. Block with a grid of Base Layers -->\n          <div fxLayout=\"row\" fxLayoutAlign=\"space-evenly center\" class=\"group-ref\">\n            <o-map-base-layer #mainBaseLayerGroup *ngFor=\"let baseLayer of baseLayers\" [layer-id]=\"baseLayer.id\"\n              [title]=\"baseLayer.name\" [src]=\"baseLayer.urlTemplate\" [active]=\"baseLayer.active\" fxLayout fxLayoutAlign=\"center center\">\n            </o-map-base-layer>\n          </div>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"showLayersMenu\">\n        <!-- Header for Layers -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <mat-panel-title>\n              {{ getText('MAP_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-tree-list if it goes into the framework. Block with a hierarquical list of Layers and LayerGroups -->\n          <div class=\"group-ref\">\n            <ng-content></ng-content>\n            <o-map-layer-group class=\"o-map-layer-group\" #mainLayerGroup></o-map-layer-group>\n          </div>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"showWorkspaceMenu\">\n        <!-- Header for Workspace -->\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n            <mat-panel-title>\n              {{ getText('MAP_WORKSPACE_LAYERS') }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n\n          <!-- TODO replace this div with o-list if it goes into the framework. Block with a simple list of WorkspaceLayers -->\n          <o-map-workspace #oMapWorkspace (onToggleWSLayerSelected)=\"onWSLayerSelected($event)\"\n            (onToggleWSLayerVisibility)=\"onWSLayerVisibilityToggled($event)\"\n            (onToggleWSLayerInWS)=\"onWSLayerInWSToggled($event)\">\n          </o-map-workspace>\n        </mat-expansion-panel>\n      </ng-container>\n\n      <ng-container *ngIf=\"mapLayerContainerComponent\">\n        <mat-expansion-panel expanded=\"true\">\n          <mat-expansion-panel-header [collapsedHeight]=\"'34px'\" [expandedHeight]=\"'34px'\">\n\n            <ng-template #headerContent [ngTemplateOutlet]=\"mapLayerContainerComponent.headerTemplateref\">\n            </ng-template>\n\n            <mat-panel-title>\n              {{ mapLayerContainerComponent.label }}\n            </mat-panel-title>\n          </mat-expansion-panel-header>\n          <ng-content select=\"o-map-layer-container\"></ng-content>\n        </mat-expansion-panel>\n      </ng-container>\n    </div>\n  </mat-sidenav>\n  <!--\n\t\tTODO o-frame sidebar container\n\t\tMap Section\n\t-->\n  <div fxLayout=\"column\" fxLayoutAlign=\"top start\" fxFlexFill>\n    <!--\n      Map container for Leaflet\n    -->\n    <div [id]=\"mapId\" class=\"leaflet-map-container\"></div>\n    <!--\n      Omnibar o-navigator\n    -->\n    <div *ngIf=\"isNavigatorVisible\" #navigatorContainer [@navigatorState]=\"navigatorState\" fxLayout=\"row\"\n      fxLayoutAlign=\"start center\">\n      <o-navigator [show-search-input]=\"searchControl\" [show-sidenav-button]=\"isSearchControlButtonVisible\">\n      </o-navigator>\n    </div>\n  </div>\n</mat-sidenav-container>", styles: ["mat-sidenav#layers{width:350px}mat-sidenav#layers .mat-toolbar.mat-toolbar-single-row{padding-left:16px;line-height:40px}mat-sidenav#layers mat-toolbar,mat-sidenav#layers mat-toolbar-row{min-height:40px;height:40px;border-bottom:2px solid #ccc;padding:0}mat-sidenav#layers mat-toolbar button,mat-sidenav#layers mat-toolbar-row button{min-width:54px;height:40px}.mat-pushed-closed{transition:all .3s cubic-bezier(.55,0,.55,.2);padding-left:0!important}.mat-sidenav-left.mat-open,mat-sidenav.mat-sidenav-opened{transform:translateZ(0);visibility:initial;transition:transform .2s ease-in;-webkit-user-select:none;user-select:none}.o-map .leaflet-map-container{position:absolute;top:0;bottom:0;width:100%}.o-map .leaflet-map-container .sidenav-toggle-btn{position:absolute;left:8px;top:8px}.o-map .group-ref{max-height:30%;overflow:auto}.o-map .mat-expansion-panel .mat-expansion-panel-header{padding:0 16px;flex-direction:row-reverse}.o-map .mat-expansion-panel .mat-expansion-panel-header .mat-content{padding-left:12px}.o-map .mat-expansion-panel .mat-expansion-panel-header-title{font-size:16px}.o-map .mat-expansion-panel .mat-expansion-panel-content{font:inherit}.o-map .mat-expansion-panel .mat-expansion-indicator{padding-bottom:6px}.o-map .mat-expansion-panel .mat-expansion-indicator.o-close-sidenav{width:24px;text-align:center;padding:0}.o-map .mat-expansion-panel .mat-expansion-indicator.o-close-sidenav:after{transform:rotate(135deg)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Injector }]; }, propDecorators: { markerComponent: [{
                type: ViewChild,
                args: [OMarkerComponent]
            }], sideNavCmp: [{
                type: ViewChild,
                args: ['sidenav']
            }], mapBaseLayerGroup: [{
                type: ViewChildren,
                args: ['mainBaseLayerGroup']
            }], mapLayerGroup: [{
                type: ViewChild,
                args: ['mainLayerGroup']
            }], mapWorkspace: [{
                type: ViewChild,
                args: ['oMapWorkspace']
            }], navigatorContainer: [{
                type: ViewChild,
                args: ['navigatorContainer']
            }], mapLayerContainerQueryList: [{
                type: ContentChildren,
                args: [OMapLayerContainerComponent]
            }], showBaseLayersMenu: [], showLayersMenu: [], showWorkspaceMenu: [], queryFeaturesInBounds: [] } });

class OMapCrsConfigurationClass {
    static getCRSFromConfigurationObject(comp) {
        let result;
        const crsParam = comp.getCRSConfigurationParam().crsConfiguration;
        let args = {};
        if (crsParam !== undefined && crsParam.epsg_args !== undefined) {
            args = crsParam.epsg_args;
        }
        if (crsParam.epsg !== undefined && crsParam.epsg_configuration !== undefined) {
            result = new L.Proj.CRS(crsParam.epsg, crsParam.epsg_configuration, args);
        }
        return result;
    }
    static getCRSObject(arg) {
        const conf = arg.getCRSConfigurationParam();
        if (conf.crs !== undefined && L.CRS && L.CRS[conf.crs]) {
            return L.CRS[conf.crs];
        }
        else if (conf.crsConfiguration !== undefined) {
            return OMapCrsConfigurationClass.getCRSFromConfigurationObject(arg);
        }
        return undefined;
    }
}

const DEFAULT_INPUTS$1 = [
    'crs',
    'crsConfiguration : crs-configuration'
];
const DEFAULT_OUTPUTS$1 = [];
class OMapCrsComponent {
    constructor(oMap) {
        this.oMap = oMap;
    }
    ngOnInit() {
        if (this.oMap) {
            this.oMap.registerCRSComponent(this);
        }
    }
    getCRSConfigurationParam() {
        return {
            crsConfiguration: this.crsConfiguration,
            crs: this.crs
        };
    }
    getCRS() {
        return OMapCrsConfigurationClass.getCRSObject(this);
    }
}
OMapCrsComponent.DEFAULT_INPUTS = DEFAULT_INPUTS$1;
OMapCrsComponent.DEFAULT_OUTPUTS = DEFAULT_OUTPUTS$1;
OMapCrsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapCrsComponent, deps: [{ token: forwardRef(() => OMapComponent) }], target: i0.ɵɵFactoryTarget.Component });
OMapCrsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapCrsComponent, selector: "o-map-crs", inputs: { crs: "crs", crsConfiguration: ["crs-configuration", "crsConfiguration"] }, ngImport: i0, template: "", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapCrsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-crs', inputs: DEFAULT_INPUTS$1, outputs: DEFAULT_OUTPUTS$1, template: "" }]
        }], ctorParameters: function () {
        return [{ type: OMapComponent, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapComponent)]
                    }] }];
    } });

const DEFAULT_INPUTS = [
    'position',
    'polylineOptions : polyline-options',
    'polygonOptions : polygon-options',
    'rectangleOptions : rectangle-options',
    'circleOptions : circle-options',
    'circleMarkerOptions : circlemarker-options',
    'markerOptions : marker-options',
    'editPolyOptions : edit-poly-options',
    'editHandlerOptions : edit-handler-options',
    'deleteHandlerOptions : delete-handler-options',
    'showControls: show-controls'
];
const DEFAULT_OUTPUTS = [];
class OMapDrawControlsComponent {
    constructor(oMap) {
        this.oMap = oMap;
        this.position = 'topright';
        this.polylineOptions = {};
        this.polygonOptions = {};
        this.rectangleOptions = {};
        this.circleOptions = {};
        this.markerOptions = {};
        this.circleMarkerOptions = {};
        this.editPolyOptions = {};
        this.editHandlerOptions = {};
        this.deleteHandlerOptions = {};
        this.showControls = true;
    }
    ngOnInit() {
        if (this.oMap) {
            this.parseDrawOptions();
            this.setOptions();
            this.addDrawControlEvents();
            this.oMap.registerDrawControlComponent(this);
            this.onMapReadySubscription = this.oMap.onMapAfterViewInit().subscribe(() => {
                this.configureDrawControl();
            });
        }
    }
    ngOnDestroy() {
        if (this.onMapReadySubscription) {
            this.onMapReadySubscription.unsubscribe();
        }
    }
    getMapService() {
        return this.oMap.getMapService();
    }
    parseDrawOptions() {
        if (this.polylineOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.polylineOptions = false;
        }
        if (this.polygonOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.polygonOptions = false;
        }
        if (this.rectangleOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.rectangleOptions = false;
        }
        if (this.circleOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.circleOptions = false;
        }
        if (this.markerOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.markerOptions = false;
        }
        if (this.circleMarkerOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.circleMarkerOptions = false;
        }
        if (this.editPolyOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.editPolyOptions = false;
        }
        if (this.editHandlerOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.editHandlerOptions = false;
        }
        if (this.deleteHandlerOptions === OMapDrawControlsComponent.EMPTY_CONTROL_TAG) {
            this.deleteHandlerOptions = false;
        }
    }
    setOptions() {
        this.options = {
            position: this.position
        };
        const drawOptions = {
            polyline: this.polylineOptions,
            polygon: this.polygonOptions,
            rectangle: this.rectangleOptions,
            circle: this.circleOptions,
            marker: this.markerOptions,
            circlemarker: this.circleMarkerOptions
        };
        this.options.draw = drawOptions;
        if (this.editPolyOptions) {
            this.editableLayers = new L.FeatureGroup();
            this.editPolyOptions = {
                featureGroup: this.editableLayers,
                remove: this.deleteHandlerOptions
            };
            if (this.editHandlerOptions) {
                this.editPolyOptions.edit = this.editHandlerOptions;
            }
        }
        this.options.edit = this.editPolyOptions;
    }
    addDrawControlEvents() {
        this.drawControlEvents = new OMapDrawControlsEvents(this.editableLayers);
    }
    configureDrawControl() {
        const map = this.oMap.getLMap();
        this.drawControl = new L.Control.Draw(this.options);
        if (this.showControls) {
            this.showDrawControl();
        }
        this.drawControlEvents.setMap(map);
    }
    removeDrawControl() {
        const map = this.oMap.getLMap();
        map.removeControl(this.drawControl);
        const mapService = this.getMapService();
        mapService.removeDrawLayer();
    }
    showDrawControl() {
        const map = this.oMap.getLMap();
        map.addControl(this.drawControl);
        const mapService = this.getMapService();
        mapService.addDrawLayer(this.editableLayers);
    }
    get editableLayers() {
        return this._editableLayers;
    }
    set editableLayers(value) {
        this._editableLayers = value;
    }
}
OMapDrawControlsComponent.DEFAULT_INPUTS = DEFAULT_INPUTS;
OMapDrawControlsComponent.DEFAULT_OUTPUTS = DEFAULT_OUTPUTS;
OMapDrawControlsComponent.EMPTY_CONTROL_TAG = 'none';
OMapDrawControlsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapDrawControlsComponent, deps: [{ token: forwardRef(() => OMapComponent) }], target: i0.ɵɵFactoryTarget.Component });
OMapDrawControlsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: OMapDrawControlsComponent, selector: "o-map-draw-controls", inputs: { position: "position", polylineOptions: ["polyline-options", "polylineOptions"], polygonOptions: ["polygon-options", "polygonOptions"], rectangleOptions: ["rectangle-options", "rectangleOptions"], circleOptions: ["circle-options", "circleOptions"], circleMarkerOptions: ["circlemarker-options", "circleMarkerOptions"], markerOptions: ["marker-options", "markerOptions"], editPolyOptions: ["edit-poly-options", "editPolyOptions"], editHandlerOptions: ["edit-handler-options", "editHandlerOptions"], deleteHandlerOptions: ["delete-handler-options", "deleteHandlerOptions"], showControls: ["show-controls", "showControls"] }, ngImport: i0, template: "", styles: [""] });
__decorate([
    BooleanInputConverter(),
    __metadata("design:type", Boolean)
], OMapDrawControlsComponent.prototype, "showControls", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapDrawControlsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'o-map-draw-controls', inputs: DEFAULT_INPUTS, outputs: DEFAULT_OUTPUTS, template: "" }]
        }], ctorParameters: function () {
        return [{ type: OMapComponent, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => OMapComponent)]
                    }] }];
    }, propDecorators: { showControls: [] } });

const OMAP_COMPONENTS = [
    OMapComponent,
    OMapBaseLayerComponent,
    OMapDrawControlsComponent,
    OMapCrsComponent,
    OMapLayerComponent,
    OMapLayerGroupComponent,
    OMapWorkspaceComponent,
    OMapWorkspaceLayerComponent,
    OToggleIconButtonComponent,
    OMarkerComponent,
    ONavigatorComponent,
    ONavigatorItemComponent,
    OMapLayerContainerComponent
];

function getTranslateMapServiceProvider(injector) {
    return new TranslateMapService(injector);
}
const OMAP_PROVIDERS = [{
        provide: TranslateMapService,
        useFactory: getTranslateMapServiceProvider,
        deps: [Injector]
    }];

class OMapModule {
}
OMapModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
OMapModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.10", ngImport: i0, type: OMapModule, declarations: [OMapComponent, OMapBaseLayerComponent, OMapDrawControlsComponent, OMapCrsComponent, OMapLayerComponent, OMapLayerGroupComponent, OMapWorkspaceComponent, OMapWorkspaceLayerComponent, OToggleIconButtonComponent, OMarkerComponent, ONavigatorComponent, ONavigatorItemComponent, OMapLayerContainerComponent], imports: [CommonModule,
        FormsModule,
        OCustomMaterialModule,
        FlexLayoutModule,
        DragDropModule], exports: [OMapComponent, OMapBaseLayerComponent, OMapDrawControlsComponent, OMapCrsComponent, OMapLayerComponent, OMapLayerGroupComponent, OMapWorkspaceComponent, OMapWorkspaceLayerComponent, OToggleIconButtonComponent, OMarkerComponent, ONavigatorComponent, ONavigatorItemComponent, OMapLayerContainerComponent] });
OMapModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapModule, providers: OMAP_PROVIDERS, imports: [CommonModule,
        FormsModule,
        OCustomMaterialModule,
        FlexLayoutModule,
        DragDropModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: OMapModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        OCustomMaterialModule,
                        FlexLayoutModule,
                        DragDropModule
                    ],
                    declarations: OMAP_COMPONENTS,
                    exports: OMAP_COMPONENTS,
                    providers: OMAP_PROVIDERS,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                }]
        }] });

class Feature {
}

class Geometry {
}

export { BaseLayerCollection, BaseLayerDefault, Center, Feature, GeocodingService, Geometry, LayerConfiguration, LayerConfigurationContextmenu, LayerConfigurationContextmenuItem, LayerGroupConfiguration, Location, MapService, OMapBaseLayerComponent, OMapComponent, OMapCrsComponent, OMapDrawControlsComponent, OMapLayerComponent, OMapLayerContainerComponent, OMapLayerFactory, OMapLayerGroupComponent, OMapLayerGroupsWarehouse, OMapModule, OMapWorkspaceComponent, OMapWorkspaceLayerComponent, OMarkerComponent, ONavigatorComponent, ONavigatorItemComponent, OToggleIconButtonComponent, SearcherDefault, TranslateMapService, Util };
//# sourceMappingURL=ontimize-web-ngx-map.mjs.map
