import { OnDestroy, OnInit } from '@angular/core';
import * as L from 'leaflet';
import { Subscription } from 'rxjs';
import { OMapComponent } from '../map/o-map.component';
import { MapService } from '../../services/MapService';
import { OMapDrawControlsEvents } from './o-map-draw-controls-events.class';
import * as i0 from "@angular/core";
export declare class OMapDrawControlsComponent implements OnInit, OnDestroy {
    protected oMap: OMapComponent;
    static DEFAULT_INPUTS: string[];
    static DEFAULT_OUTPUTS: any[];
    protected static EMPTY_CONTROL_TAG: string;
    drawControl: L.Control.Draw;
    protected position: 'topleft' | 'topright' | 'bottomleft' | 'bottomright';
    protected polylineOptions: L.DrawOptions.PolylineOptions | boolean;
    protected polygonOptions: L.DrawOptions.PolygonOptions | boolean;
    protected rectangleOptions: L.DrawOptions.RectangleOptions | boolean;
    protected circleOptions: L.DrawOptions.CircleOptions | boolean;
    protected markerOptions: L.DrawOptions.MarkerOptions | boolean;
    protected circleMarkerOptions: {};
    protected editPolyOptions: any;
    protected editHandlerOptions: any;
    protected deleteHandlerOptions: any;
    protected options: any;
    drawControlEvents: OMapDrawControlsEvents;
    private _editableLayers;
    protected onMapReadySubscription: Subscription;
    protected showControls: boolean;
    constructor(oMap: OMapComponent);
    ngOnInit(): void;
    ngOnDestroy(): void;
    getMapService(): MapService;
    protected parseDrawOptions(): void;
    protected setOptions(): void;
    protected addDrawControlEvents(): void;
    configureDrawControl(): void;
    removeDrawControl(): void;
    showDrawControl(): void;
    get editableLayers(): L.FeatureGroup;
    set editableLayers(value: L.FeatureGroup);
    static ɵfac: i0.ɵɵFactoryDeclaration<OMapDrawControlsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OMapDrawControlsComponent, "o-map-draw-controls", never, { "position": "position"; "polylineOptions": "polyline-options"; "polygonOptions": "polygon-options"; "rectangleOptions": "rectangle-options"; "circleOptions": "circle-options"; "circleMarkerOptions": "circlemarker-options"; "markerOptions": "marker-options"; "editPolyOptions": "edit-poly-options"; "editHandlerOptions": "edit-handler-options"; "deleteHandlerOptions": "delete-handler-options"; "showControls": "show-controls"; }, {}, never, never, false, never>;
}
