import { AfterViewInit, EventEmitter, Injector, OnDestroy, OnInit } from '@angular/core';
import * as L from 'leaflet';
import { Observable, Subscription } from 'rxjs';
import { LayerConfigurationContextmenu, LayerConfiguration } from '../../models/LayerConfiguration.class';
import { OMapLayerOptions } from '../../types/layer-options.type';
import { ICRSConfiguration, ICRSConfigurationParameter } from '../map-crs/o-map-crs-configuration.class';
import { MapService } from '../../services/MapService';
import { OSearchable, OSearchResult } from '../../interfaces/search/searchable.interface';
import { TranslateMapService } from '../../services/TranslateMapService';
import { Center } from '../../models/Center.class';
import { ILayerService } from '../../interfaces/ILayerService';
import { OMapBase } from '../map/o-map-base.class';
import * as i0 from "@angular/core";
export declare class OMapLayerComponent implements OnInit, AfterViewInit, OSearchable, OnDestroy {
    protected oMap: OMapBase;
    protected injector: Injector;
    sCenter: string;
    sPoints: string;
    sRadius: string;
    sBounds: string;
    sService: string;
    selected: boolean;
    visible: boolean;
    inWS: boolean;
    inMenu: string;
    protected _layerId: string;
    layerGroupId: string;
    type: string;
    center: Center;
    points: any[];
    radius: number;
    bounds: any;
    popup: string;
    popupUrl: string;
    protected _menuLabel: string;
    protected _menuLabelSecondary: string;
    service: ILayerService;
    baseUrl: string;
    protected _icon: string;
    options: OMapLayerOptions;
    protected _contextmenu: any;
    queryFeaturesInBounds: boolean;
    protected crs: string;
    protected crsConfiguration: ICRSConfiguration;
    protected translateMapService: TranslateMapService;
    oSearchKeys: Array<string>;
    layer: L.Layer;
    protected layerConf: LayerConfiguration;
    private rendered;
    private _clickEvtEmitter;
    private _dblClickEvtEmitter;
    private _mouseDownEvtEmitter;
    private _mouseUpEvtEmitter;
    private _mouseOverEvtEmitter;
    private _mouseOutEvtEmitter;
    private _mouseMoveEvtEmitter;
    private _dragStartEvtEmitter;
    private _dragEvtEmitter;
    private _dragEndEvtEmitter;
    private _resizeEvtEmitter;
    private _popupOpenEvtEmitter;
    private _popupCloseEvtEmitter;
    private _contextmenuEvtEmitter;
    protected oMapConfigurationSubscription: Subscription;
    protected layerAfterViewInitStream: EventEmitter<Object>;
    protected layerMapConfigured: EventEmitter<Object>;
    protected layerStream: Observable<any>;
    protected layerStreamSubscription: Subscription;
    constructor(oMap: OMapBase, injector: Injector);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    getCRSConfigurationParam(): ICRSConfigurationParameter;
    get oSearchResult(): OSearchResult;
    getMapService(): MapService;
    getMapLayerFactory(): any;
    getLayerConfiguration(): LayerConfiguration;
    createLayerConfiguration(): LayerConfiguration;
    initializeMapLayer(): void;
    createMapLayer(layerConf: LayerConfiguration): void;
    setSelected(status: boolean): boolean;
    toggleSelected(status?: boolean): boolean;
    setInWS(status: boolean): boolean;
    toggleInWS(status?: boolean): boolean;
    setVisible(status: boolean): boolean;
    toggleVisible(status?: boolean): boolean;
    setZIndex(i: number): void;
    updateStatus(): void;
    bindLayerEvents(): void;
    onClickEvent(onNext: (value: any) => void): Subscription;
    onDoubleClickEvent(onNext: (value: any) => void): Subscription;
    onMouseDownEvent(onNext: (value: any) => void): Subscription;
    onMouseUpEvent(onNext: (value: any) => void): Subscription;
    onMouseOverEvent(onNext: (value: any) => void): Subscription;
    onMouseOutEvent(onNext: (value: any) => void): Subscription;
    onMouseMoveEvent(onNext: (value: any) => void): Subscription;
    onDragStartEvent(onNext: (value: any) => void): Subscription;
    onDragEvent(onNext: (value: any) => void): Subscription;
    onDragEndEvent(onNext: (value: any) => void): Subscription;
    onResizeEvent(onNext: (value: any) => void): Subscription;
    onPopupCloseEvent(onNext: (value: any) => void): Subscription;
    onPopupOpenEvent(onNext: (value: any) => void): Subscription;
    loadPopupTpl(): Observable<any>;
    get layerId(): string;
    set layerId(val: string);
    get icon(): string;
    set icon(val: string);
    get menuLabelSecondary(): string;
    set menuLabelSecondary(val: string);
    get menuLabel(): string;
    set menuLabel(val: string);
    set contextMenu(val: LayerConfigurationContextmenu);
    get contextMenu(): LayerConfigurationContextmenu;
    static ɵfac: i0.ɵɵFactoryDeclaration<OMapLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OMapLayerComponent, "o-map-layer", never, { "sCenter": "layer-center"; "sPoints": "layer-points"; "sRadius": "layer-radius"; "sBounds": "layer-bounds"; "sService": "layer-service"; "baseUrl": "layer-base-url"; "selected": "layer-selected"; "visible": "layer-visible"; "inWS": "layer-in-ws"; "inMenu": "layer-in-menu"; "layerId": "layer-id"; "layerGroupId": "layer-group-id"; "type": "layer-type"; "popup": "layer-popup"; "popupUrl": "layer-popup-url"; "menuLabel": "layer-menu-label"; "menuLabelSecondary": "layer-menu-label-secondary"; "icon": "layer-icon"; "options": "layer-options"; "crs": "crs"; "crsConfiguration": "crs-configuration"; "contextMenu": "layer-contextmenu"; "queryFeaturesInBounds": "query-features-in-bounds"; }, {}, never, never, false, never>;
}
