import { EventEmitter } from '@angular/core';
import * as L from 'leaflet';
import { BehaviorSubject } from 'rxjs';
import { Zoom } from '../../interfaces/IZoom';
import { Center } from '../../models/Center.class';
import { MapService } from '../../services/MapService';
import { TranslateMapService } from '../../services/TranslateMapService';
import { OMapBaseLayerComponent } from '../map-base-layer/o-map-base-layer.component';
import { OMapLayerComponent } from '../map-layer/o-map-layer.component';
export declare class OMapBase {
    zoom: Zoom;
    protected translateMapService: TranslateMapService;
    protected mapBaseLayerGroup: Array<OMapBaseLayerComponent>;
    protected mapLayers: Array<OMapLayerComponent>;
    protected mapService: MapService;
    protected mapConfiguration: EventEmitter<any>;
    protected mapAfterViewInit: EventEmitter<any>;
    protected mapReady: BehaviorSubject<any>;
    private center;
    getOMapLayer(layerId: string): OMapLayerComponent;
    getOMapLayers(): Array<OMapLayerComponent>;
    addOMapLayer(layer: OMapLayerComponent): void;
    getMapService(): MapService;
    getLMap(): L.Map;
    getCenter(): Center;
    setCenter(sCenter: string): void;
    addMarker(id: any, latitude: any, longitude: any, options: any, popup: any, hidden: any, showInMenu: any, menuLabel: any): void;
    onMapConfigured(): EventEmitter<any>;
    onMapAfterViewInit(): EventEmitter<any>;
    onMapReady(): BehaviorSubject<any>;
}
