import { AfterViewInit, ElementRef, EventEmitter, Injector, OnDestroy, OnInit, QueryList } from '@angular/core';
import { MatSidenav } from '@angular/material/sidenav';
import { MatTab, MatTabGroup } from '@angular/material/tabs';
import { Subscription } from 'rxjs';
import { OMapLayerGroup } from '../../interfaces/o-map-layer-group.interface';
import { OMapWorkspace } from '../../interfaces/o-map-workspace.interface';
import { LayerConfigurationContextmenu } from '../../models/LayerConfiguration.class';
import type { OMapBaseLayerComponent } from '../map-base-layer/o-map-base-layer.component';
import { OMapCrsComponent } from '../map-crs/o-map-crs.component';
import { OMapLayerContainerComponent } from '../map-layer-container/o-map-layer-container.component';
import { OMarkerComponent } from '../marker/o-marker.component';
import { OMapWSearch } from './o-map-w-search.class';
import * as i0 from "@angular/core";
export declare class OMapComponent extends OMapWSearch implements OnInit, AfterViewInit, OnDestroy {
    protected elRef: ElementRef;
    protected injector: Injector;
    static DEFAULT_INPUTS: string[];
    static DEFAULT_OUTPUTS: string[];
    markerComponent: OMarkerComponent;
    sideNavCmp: MatSidenav;
    mapBaseLayerGroup: Array<OMapBaseLayerComponent>;
    mapLayerGroup: OMapLayerGroup;
    mapWorkspace: OMapWorkspace;
    navigatorContainer: ElementRef;
    protected mapLayerContainerQueryList: QueryList<OMapLayerContainerComponent>;
    mapLayerContainerComponent: OMapLayerContainerComponent;
    onToggleWSLayerSelected: EventEmitter<Object>;
    onToggleWSLayerVisibility: EventEmitter<Object>;
    onToggleWSLayerInWS: EventEmitter<Object>;
    set sCenter(center: string);
    sAttr: string;
    sZoom: string;
    sMinZoom: string;
    sMaxZoom: string;
    sZoomControl: string;
    sSearchControl: string;
    sSearchControlButtonVisible: string;
    sDrawControl: string;
    sLayerPanelVisible: string;
    sBaseLayerIds: string;
    private _sidenavMode;
    get sidenavMode(): 'over' | 'push' | 'side';
    set sidenavMode(value: 'over' | 'push' | 'side');
    showBaseLayersMenu: boolean;
    showLayersMenu: boolean;
    showWorkspaceMenu: boolean;
    queryFeaturesInBounds: boolean;
    mapId: string;
    protected baseLayerIds: Array<string>;
    protected tabGroupContainer: MatTabGroup;
    protected tabContainer: MatTab;
    protected tabGroupSubscription: Subscription;
    protected _waitForBuild: boolean;
    protected _searchControl: boolean;
    protected _searchControlButtonVisible: boolean;
    protected crsComponent: OMapCrsComponent;
    protected _contextmenu: any;
    constructor(elRef: ElementRef, injector: Injector);
    getInjector(): Injector;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initialize(): void;
    registerCRSComponent(crsComp: OMapCrsComponent): void;
    registerTabGroupListener(): void;
    ngOnDestroy(): void;
    get waitForBuild(): boolean;
    set waitForBuild(val: boolean);
    onWSLayerSelected(event: any): void;
    onWSLayerVisibilityToggled(event: any): void;
    onWSLayerInWSToggled(event: any): void;
    getText(text: string): string;
    protected configureMap(): void;
    get searchControl(): boolean;
    set searchControl(val: boolean);
    get isSearchControlButtonVisible(): boolean;
    set isSearchControlButtonVisible(val: boolean);
    get isNavigatorVisible(): boolean;
    get navigatorState(): any;
    get navigatorExpandedPosition(): string;
    set contextMenu(val: LayerConfigurationContextmenu);
    get contextMenu(): LayerConfigurationContextmenu;
    static ɵfac: i0.ɵɵFactoryDeclaration<OMapComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OMapComponent, "o-map", never, { "sAttr": "attr"; "sCenter": "center"; "sZoom": "zoom"; "sMinZoom": "min-zoom"; "sMaxZoom": "max-zoom"; "sZoomControl": "zoom-control"; "sSearchControl": "search-control"; "sSearchControlButtonVisible": "search-control-button-visible"; "sDrawControl": "draw-control"; "sLayerPanelVisible": "layer-panel-visible"; "sBaseLayerIds": "base-layer-ids"; "sidenavMode": "sidenav-mode"; "showBaseLayersMenu": "show-base-layers-menu"; "showLayersMenu": "show-layers-menu"; "showWorkspaceMenu": "show-workspace-menu"; "contextMenu": "layer-contextmenu"; "queryFeaturesInBounds": "query-features-in-bounds"; }, { "onToggleWSLayerSelected": "onToggleWSLayerSelected"; "onToggleWSLayerVisibility": "onToggleWSLayerVisibility"; "onToggleWSLayerInWS": "onToggleWSLayerInWS"; "onClick": "onClick"; "onDrag": "onDrag"; "onMove": "onMove"; "onMoveEnd": "onMoveEnd"; "onZoomLevelsChange": "onZoomLevelsChange"; "onZoomStart": "onZoomStart"; "onZoomEnd": "onZoomEnd"; "onZoom": "onZoom"; "onDrawEvent": "onDrawEvent"; "onDrawCreated": "onDrawCreated"; "onDrawEdited": "onDrawEdited"; "onDrawDeleted": "onDrawDeleted"; "onDrawDrawStart": "onDrawDrawStart"; "onDrawDrawstop": "onDrawDrawstop"; "onDrawvertex": "onDrawvertex"; "onDrawEditStart": "onDrawEditStart"; "onDrawEditMove": "onDrawEditMove"; "onDrawEditResize": "onDrawEditResize"; "onDrawEditvertex": "onDrawEditvertex"; "onDrawEditStop": "onDrawEditStop"; "onDrawDeleteStart": "onDrawDeleteStart"; "onDrawDeleteStop": "onDrawDeleteStop"; }, ["mapLayerContainerQueryList"], ["*", "o-map-layer-container"], false, never>;
}
