import { OnDestroy } from '@angular/core';
import { Subscription } from 'rxjs';
import { GeocodingService } from '../../services/GeocodingService';
import { TranslateMapService } from '../../services/TranslateMapService';
import { ONavigatorDefault } from './o-navigator.class';
import { OMapBase } from '../map/o-map-base.class';
import * as i0 from "@angular/core";
export declare class ONavigatorComponent extends ONavigatorDefault implements OnDestroy {
    static DEFAULT_INPUTS: string[];
    showSidenavButton: boolean;
    showSearchInput: boolean;
    protected _rendered: boolean;
    protected oMapConfigurationSubscription: Subscription;
    constructor(geocoder: GeocodingService, translateMapService: TranslateMapService, oMap: OMapBase);
    ngOnDestroy(): void;
    getText(text: string): string;
    get address(): string;
    set address(address: string);
    toggleSidenav(e: MouseEvent): void;
    onBlur(): void;
    onFocus(): void;
    get rendered(): boolean;
    set rendered(val: boolean);
    get isSearchInputVisible(): boolean;
    set isSearchInputVisible(val: boolean);
    get isSidenavButtonVisible(): boolean;
    set isSidenavButtonVisible(val: boolean);
    static ɵfac: i0.ɵɵFactoryDeclaration<ONavigatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ONavigatorComponent, "o-navigator", never, { "showSidenavButton": "show-sidenav-button"; "showSearchInput": "show-search-input"; }, {}, never, never, false, never>;
}
