import { Layer } from 'leaflet';
import { OMapLayerOptions } from '../types/layer-options.type';
import { Center } from './Center.class';
export declare class LayerConfiguration {
    layerId: string;
    layerGroupId: string;
    type: string;
    center: Center;
    points: any[];
    radius: number;
    bounds: any;
    popup: string;
    popupUrl: string;
    menuLabel: string;
    menuLabelSecondary: string;
    service: string;
    baseUrl: string;
    options: OMapLayerOptions;
    showInMenu: string;
    selected: boolean;
    visible: boolean;
    inWS: boolean;
    contextmenu: LayerConfigurationContextmenu;
}
export type LayerConfigurationFunction = (e: Layer) => LayerConfigurationContextmenuItem[];
export declare class LayerConfigurationContextmenu {
    contextmenuWidth?: number;
    contextmenuItems?: LayerConfigurationContextmenuItem[];
    contextmenuCallback?: Function;
    defaultContextmenuItems?: boolean;
    callback?: LayerConfigurationFunction;
}
export declare class LayerConfigurationContextmenuItem {
    label: string;
    attr?: string;
    index?: number;
    defaultContextmenuItems?: boolean;
    callback?: Function;
    icon?: string;
    separator?: boolean;
}
