import { EventEmitter, Injector } from '@angular/core';
import * as L from 'leaflet';
import { Map } from 'leaflet';
import 'leaflet-contextmenu';
import 'leaflet-draw';
import 'leaflet-providers';
import 'leaflet.heat';
import 'leaflet.markercluster';
import 'proj4leaflet';
import { TranslateMapService } from './TranslateMapService';
import { OMapLayerOptions } from '../types/layer-options.type';
import { BaseLayerCollection } from '../models/BaseLayerCollection.class';
import { LayerConfigurationContextmenu } from '../models/LayerConfiguration.class';
import * as i0 from "@angular/core";
export declare class MapService {
    protected injector: Injector;
    static DEFAULT_BASE_MAP: string;
    map: Map;
    layers: Object;
    controls: Object;
    baseLayers: BaseLayerCollection;
    overlayMaps: L.Control.LayersObject;
    iconTypes: Object;
    drawLayerId: string;
    translateMapService: TranslateMapService;
    popupOptions: Object;
    defaultContextMenu: LayerConfigurationContextmenu;
    baseLayerSelected: EventEmitter<any>;
    constructor(injector: Injector);
    centerMap(e: any): void;
    zoomIn(): void;
    zoomOut(): void;
    disableMouseEvent(tag: string): void;
    getMap(id?: string, options?: L.MapOptions): Map;
    setCenter(latitude: number, longitude: number): void;
    getCenter(): L.LatLng;
    setZoom(zoom: number): void;
    getZoom(): any;
    getDefaultContextmenuItems(): LayerConfigurationContextmenu;
    addLayer(id: any, layer: any, hidden: boolean, showInMenu: string, menuLabel: string): void;
    addDrawLayer(layer: any): void;
    removeDrawLayer(): void;
    getDrawLayer(): L.Control.LayersObject;
    configureBaseLayers(baseLayerIds: Array<string>): void;
    selectBaseLayer(id: string): void;
    uploadBaseLayers(): void;
    clearBaseLayers(): void;
    removeLayer(id: string): boolean;
    clearLayers(): void;
    getLayer(id: string): any;
    createIconType(id: any, options: any): any;
    createIcon(options: any, type: any): any;
    addTileLayer(id: any, template: any, options: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addTileLayerWMS(id: any, baseUrl: any, optionsArg: OMapLayerOptions, hidden: any, showInMenu: any, menuLabel: any): any;
    addMarker(id: any, latitude: any, longitude: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addImageOverlay(id: any, url: any, left: any, bottom: any, right: any, top: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addPolyline(id: any, points: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): L.Polyline<any>;
    addMultiPolyline(id: any, points: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addPolygon(id: any, points: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addMultiPolygon(id: any, points: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addRectangle(id: any, left: any, bottom: any, right: any, top: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addCircle(id: any, latitude: any, longitude: any, radius: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addLayerGroup(id: any, layers: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addFeatureGroup(id: any, layers: any, popup: any, hidden: any, showInMenu: any, menuLabel: any): any;
    addGeoJSON(id: any, data: any, optionsArg: OMapLayerOptions, popup: any, hidden: any, showInMenu: any, menuLabel: any, contextmenu: any): L.GeoJSON;
    parseContextmenuItems(items: Array<any>): Array<any>;
    popupTemplate(str: any, data: any): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<MapService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MapService>;
}
